/* hst2_dat -- memory allocation & data read
	minor amendment in reading data   1019
*/

#include <stdlib.h>
#include <math.h>
#include "histo2.h"

#define CNGX "** Due to negative data, curve of log-normal dist was discontinued! **\n"

extern char File1[NF], File2[NF], Filet[NF], Filep[NF];
extern unsigned int Opt;
extern int N1, N2, Nt, Nfrq;
extern double *X1, *X2, *Xt, dX, Xmax, Xmin, Ymax, Ymin, Ymaxt, *Frq1, *Frq2, *Frqt, \
	Mxl1, Sxl1, Mxg1, Sxg1, Mxl2, Sxl2, Mxg2, Sxg2, Mxt, Sxt, Mxlt, Sxlt, Mxgt, Sxgt;
static double vxl1, vxl2, vxlt, dmax, dmax1, dmax2, dmin, dum, dum1, dum2;

void hst2_dat(mx1, sx1, maxx1, minx1, mx2, sx2, maxx2, minx2)
double *mx1, *sx1, *maxx1, *minx1, *mx2, *sx2, *maxx2, *minx2;
{
	int i;
	double rangep, maxy, maxyt;

	/* read data X1[] & X2[] and calculate mean, stdev, ... */

	X1 = mallocvd(N1);   X2 = mallocvd(N2);
	hst2_read_x(File1, N1, X1, mx1, sx1, maxx1, minx1, &Mxl1, &vxl1, &Sxl1, &Mxg1, &Sxg1);
	hst2_read_x(File2, N2, X2, mx2, sx2, maxx2, minx2, &Mxl2, &vxl2, &Sxl2, &Mxg2, &Sxg2);
	if (Opt & TOTALHST_BIT){
		Xt = mallocvd(Nt);
		for (i=0; i<N1; i++) Xt[i] = X1[i];
		for (i=0; i<N2; i++) Xt[N1+i] = X2[i];
		meanvar(Nt, Xt, &Mxt, &dum, &Sxt);
		if (Opt & LOGNORM_BIT){
			meanvarl(Nt, Xt, &Mxlt, &vxlt, &Sxlt, &Mxgt, &dum);
			Sxgt = sqrt(dum);
		}
	}

	/* determine X range & count frequency */

	if (!(Opt & XRANGE_BIT)){
		dmax = MAX((*maxx1), (*maxx2));   dmin = MIN((*minx1), (*minx2));
		rangep = RANGEFACT*(dmax - dmin);
		Xmax = dmax + rangep;
		Xmin = dmin - rangep;
	}
	if (!(Opt & BIN_WIDTH_BIT)){
		dX = (Xmax - Xmin)/NBINDFLT;
		Nfrq = NBINDFLT;
	}
	else {
		Nfrq = ceil((Xmax - Xmin)/dX);
	}
	Frq1 = mallocvd(Nfrq);   Frq2 = mallocvd(Nfrq);
	histd(N1, X1, Xmin, dX, Nfrq, Frq1);   histd(N2, X2, Xmin, dX, Nfrq, Frq2);
	if (Opt & TOTALHST_BIT){
		Frqt = mallocvd(Nfrq);
		histd(Nt, Xt, Xmin, dX, Nfrq, Frqt);
	}

	/* determine Y range */

	if (!(Opt & YRANGE_BIT)) cal_maxy(*sx1, *sx2, &maxy);
	if (Opt & TOTALHST_BIT) cal_maxyt(&maxyt);
	if (!(Opt & YRANGE_BIT) && !(Opt & TOTALHST_BIT)){
		rangep = RANGEFACT*(maxy - Ymin);
		Ymax = maxy + rangep;
	}
	else if (!(Opt & YRANGE_BIT) && (Opt & TOTALHST_BIT)){
		rangep = RANGEFACT*(maxy - Ymin);
		Ymax = maxy + rangep;
		rangep = RANGEFACT*(maxyt - Ymin);
		Ymaxt = maxyt + rangep;
	}
	else if ((Opt & YRANGE_BIT) && (Opt & TOTALHST_BIT)){
		cal_maxy(*sx1, *sx2, &maxy);
		Ymaxt = (Ymax - Ymin)*(maxyt/maxy) + Ymin;
	}
}

/* hst2_read_x -- read X1[] or X2[] and calculate means, stdev, etc. */

void hst2_read_x(file, n, x, mx, sx, maxx, minx, mxl, vxl, sxl, mxg, sxg)
char *file;
int n;
double *x, *mx, *sx, *maxx, *minx, *mxl, *vxl, *sxl, *mxg, *sxg;
{
	FILE *fp;
	char s1[30];
	int i, ns, flagngx=0;

	if ((fp=fopen(file,"r")) == NULL) error("Error of open file!");
	i = 0;
	while ((ns=get_s(fp,1,s1)) != EOF){
		if (ns==0 || s1[0]=='#' || s1[0]=='%') continue;
		x[i] = atof(s1);
		if (x[i]<=0. && (Opt & LOGNORM_BIT) && flagngx==0){
			fprintf(stdout, CNGX);
			Opt &= ~LOGNORM_BIT;
			flagngx = 1;
		}
		i++;
	}
	if (i != n ) error("Miss count of data!");
	fclose(fp);
	meanvar(n, x, mx, &dum, sx);
	maxmin(n, x, maxx, minx);
	if (Opt & LOGNORM_BIT){
		meanvarl(n, x, mxl, vxl, sxl, mxg, &dum);
		*sxg = sqrt(dum);
	}
}

/* cal_maxy -- calculate the maximum y-value among data1 and data2 */

void cal_maxy(s1, s2, mxy)
double s1, s2, *mxy;
{
	maxmin(Nfrq, Frq1, &dmax1, &dum);   maxmin(Nfrq, Frq2, &dmax2, &dum);
	dmax = MAX(dmax1, dmax2);
	if (!(Opt & NORM_BIT) && !(Opt & LOGNORM_BIT))
		*mxy = dmax;
	else if ((Opt & NORM_BIT) && !(Opt & LOGNORM_BIT)){
		max_norm_crv(s1, s2, &dum);
		*mxy = MAX(dmax, dum);
	}
	else if (!(Opt & NORM_BIT) && (Opt & LOGNORM_BIT)){
		max_lnorm_crv(vxl1, vxl2, Mxl1, Mxl2, Sxl1, Sxl2, &dum);
		*mxy = MAX(dmax, dum);
	}
	else {
		max_norm_crv(s1, s2, &dum);
		max_lnorm_crv(vxl1, vxl2, Mxl1, Mxl2, Sxl1, Sxl2, &dum1);
		dum2 = MAX(dum, dum1);
		*mxy = MAX(dmax, dum2);
	}
}

/* cal_maxyt -- calculate the maximum y-value in totaled data */

void cal_maxyt(mxyt)
double *mxyt;
{
	maxmin(Nfrq, Frqt, &dmax, &dum);
	if (!(Opt & NORM_BIT) && !(Opt & LOGNORM_BIT))
		*mxyt = dmax;
	else if ((Opt & NORM_BIT) && !(Opt & LOGNORM_BIT)){
		dum = Nt*dX/(sqrt(DPAI)*Sxt);
		*mxyt = MAX(dmax, dum);
	}
	else if (!(Opt & NORM_BIT) && (Opt & LOGNORM_BIT)){
		dum = Nt*exp(vxlt/2. - Mxlt)*dX/(sqrt(DPAI)*Sxlt);
		*mxyt = MAX(dmax, dum);
	}
	else {
		dum = Nt*dX/(sqrt(DPAI)*Sxt);
		dum1 = Nt*exp(vxlt/2. - Mxlt)*dX/(sqrt(DPAI)*Sxlt);
		dum2 = MAX(dum, dum1);
		*mxyt = MAX(dmax, dum2);
	}
}

/* max_norm_crv -- take larger maximum of the two normal curves */

void max_norm_crv(s1, s2, max)
double s1, s2, *max;
{
	dmax1 = N1*dX/(sqrt(DPAI)*s1);
	dmax2 = N2*dX/(sqrt(DPAI)*s2);
	*max = MAX(dmax1, dmax2);
}

/* max_lnorm_crv -- take larger maximum of the two log-normal curves */

void max_lnorm_crv(vxl1, vxl2, mxl1, mxl2, sxl1, sxl2, max)
double vxl1, vxl2, mxl1, mxl2, sxl1, sxl2, *max;
{
	dmax1 = N1*exp(vxl1/2. - mxl1)*dX/(sqrt(DPAI)*sxl1);
	dmax2 = N2*exp(vxl2/2. - mxl2)*dX/(sqrt(DPAI)*sxl2);
	*max = MAX(dmax1, dmax2);
}

/* hst2_mfree -- free memories */

void hst2_mfree()
{
	freevd(X1);   freevd(X2);   freevd(Xt);
	freevd(Frq1);   freevd(Frq2);   freevd(Frqt);
}
#undef CNGX
