/* hst2_hist -- plot histograms & distribution curves using GMT 5 (classic mode of GMT 6)
		array sizes of tick & buf increased   031921
*/

#include <string.h>
#include <math.h>
#include "histo2.h"

extern char File1[NF], File2[NF], Filet[NF], Filep[NF];
extern unsigned int Opt;
extern int N1, N2, Nt, Nfrq;
extern double Xmax, Xmin, dX, Ymax, Ymin, Ymaxt, *Frq1, *Frq2, *Frqt, Mxl1, Sxl1, Mxl2, Sxl2, \
	Mxt, Sxt, Mxlt, Sxlt;
static FILE *fp;
static int i;
static double Frcn[NFRC], Frcl[NFRC];

void hst2_hist(mx1, sx1, mx2, sx2)
double mx1, sx1, mx2, sx2;
{
	char map[100], range[100], tick[500], sbar[100], pen[100], shift[50], pok[50], \
		optf[200], buf[300];
	double x0, x0c, dxc, dxg, ddxg, dyg, ddyg, mpheight;

/* First, plot the Lower Figure with data2 from File2 */

	/* Lower Fig.: prepare maps */

	sys_call(2, "gmt gmtset", GSET);
	if (!(Opt & TOTALHST_BIT)) mpheight = MAPHEIGHT;
	else mpheight = MAPHEIGHT2;
	sprintf(map, " -JX%.2f/%.2f", MAPWIDTH, mpheight);
	g_xmax_dx(Xmax, Xmin, &dxg, &ddxg);
	g_xmax_dx(Ymax, Ymin, &dyg, &ddyg);
	sprintf(range, " -R%.4g/%.4g/%.4g/%.4g", Xmin, Xmax, Ymin, Ymax);
	sprintf(tick," -BWeS -Bxa%.4gf%.4g+lData -Bya%.4gf%.4g+lFrequency",dxg,ddxg,dyg,ddyg);
	sprintf(sbar, " -Sb%.4g", MAPWIDTH*dX/(Xmax - Xmin));
	sprintf(pen, " -Wthinnest -Glightgray");
	sprintf(shift, " -X5.0 -Y2.5");
	sprintf(pok, " -P -K >");

	/* Lower Fig.: set initials of bin & curves, calculate dist curves of data2 */

	x0 = Xmin + dX/2.;   dxc = (Xmax - Xmin)/NFRC;   x0c = Xmin + dxc/2.;
	if (Opt & NORM_BIT) cal_curven_data(N2, mx2, sx2, x0c, dxc);
	if (Opt & LOGNORM_BIT) cal_curvel_data(N2, Mxl2, Sxl2, x0c, dxc);

	/* Lower Fig.: plot a histogram and distribution curves */

	wrt_xy_data(Nfrq, x0, dX, Frq2);
	if (!(Opt & NORM_BIT) && !(Opt & LOGNORM_BIT)){
		sys_call(10, "gmt psxy ", Filet, map, range, tick, sbar, pen, shift, pok, Filep);
		sprintf(pok, " -P -O -K >>");
	}
	else if ((Opt & NORM_BIT) && !(Opt & LOGNORM_BIT)){
		sys_call(10, "gmt psxy ", Filet, map, range, tick, sbar, pen, shift, pok, Filep);
		wrt_xy_data(NFRC, x0c, dxc, Frcn);
		sprintf(pok, " -P -O -K >>");
		sprintf(pen, " -Wthinner");
		sys_call(7, "gmt psxy ", Filet, map, range, pen, pok, Filep);
	}
	else if (!(Opt & NORM_BIT) && (Opt & LOGNORM_BIT)){
		sys_call(10, "gmt psxy ", Filet, map, range, tick, sbar, pen, shift, pok, Filep);
		wrt_xy_data(NFRC, x0c, dxc, Frcl);
		sprintf(pok, " -P -O -K >>");
		sprintf(pen, " -Wthinner");
		sys_call(7, "gmt psxy ", Filet, map, range, pen, pok, Filep);
	}
	else {
		sys_call(10, "gmt psxy ", Filet, map, range, tick, sbar, pen, shift, pok, Filep);
		wrt_xy_data(NFRC, x0c, dxc, Frcn);
		sprintf(pok, " -P -O -K >>");
		sprintf(pen, " -Wthinner");
		sys_call(7, "gmt psxy ", Filet, map, range, pen, pok, Filep);
		wrt_xy_data(NFRC, x0c, dxc, Frcl);
		sprintf(pen, " -Wthin,.");
		sys_call(7, "gmt psxy ", Filet, map, range, pen, pok, Filep);
	}

	/* Lower Fig.: write texts of file name and data number */

	sprintf(buf, "%s (N=%d)", File2, N2);
	wrt_a_text(Xmax-.025*(Xmax-Xmin), Ymax-.05*(Ymax-Ymin), buf);
	sprintf(optf, " -N -F+f12p,Helvetica-Bold,black+jTR");
	sys_call(7, "gmt pstext ", Filet, map, range, optf, pok, Filep);

/* Second, plot the upper figure with data1 from File1 */

	/* Upper Fig.: map parameters */

	if (!(Opt & TOTALHST_BIT))
		sprintf(tick," -BWesn+t\"Histograms of %s and %s\" -Bxa%.4gf%.4g -Bya%.4gf%.4g+lFrequency",File1,File2,dxg,ddxg,dyg,ddyg);
	else
		sprintf(tick," -BWes -Bxa%.4gf%.4g -Bya%.4gf%.4g+lFrequency",dxg,ddxg,dyg,ddyg);
	sprintf(pen, " -Wthinnest -Glightgray");
	sprintf(shift, " -Y%-.2f", mpheight);

	/* Upper Fig.: calculate distribution curves for data1 */

	if (Opt & NORM_BIT) cal_curven_data(N1, mx1, sx1, x0c, dxc);
	if (Opt & LOGNORM_BIT) cal_curvel_data(N1, Mxl1, Sxl1, x0c, dxc);

	/* Upper Fig.: plot a histogram and distribution curves */

	wrt_xy_data(Nfrq, x0, dX, Frq1);
	if (!(Opt & NORM_BIT) && !(Opt & LOGNORM_BIT))
		sys_call(10, "gmt psxy ", Filet, map, range, tick, sbar, pen, shift, pok, Filep);
	else if ((Opt & NORM_BIT) && !(Opt & LOGNORM_BIT)){
		sys_call(10, "gmt psxy ", Filet, map, range, tick, sbar, pen, shift, pok, Filep);
		wrt_xy_data(NFRC, x0c, dxc, Frcn);
		sprintf(pen, " -Wthinner");
		sys_call(7, "gmt psxy ", Filet, map, range, pen, pok, Filep);
	}
	else if (!(Opt & NORM_BIT) && (Opt & LOGNORM_BIT)){
		sys_call(10, "gmt psxy ", Filet, map, range, tick, sbar, pen, shift, pok, Filep);
		wrt_xy_data(NFRC, x0c, dxc, Frcl);
		sprintf(pen, " -Wthinner");
		sys_call(7, "gmt psxy ", Filet, map, range, pen, pok, Filep);
	}
	else {
		sys_call(10, "gmt psxy ", Filet, map, range, tick, sbar, pen, shift, pok, Filep);
		wrt_xy_data(NFRC, x0c, dxc, Frcn);
		sprintf(pen, " -Wthinner");
		sys_call(7, "gmt psxy ", Filet, map, range, pen, pok, Filep);
		wrt_xy_data(NFRC, x0c, dxc, Frcl);
		sprintf(pen, " -Wthin,.");
		sys_call(7, "gmt psxy ", Filet, map, range, pen, pok, Filep);
	}

	/* Upper Fig.: write texts of file name and data number */

	sprintf(buf, "%s (N=%d)", File1, N1);
	wrt_a_text(Xmax-.025*(Xmax-Xmin), Ymax-.05*(Ymax-Ymin), buf);
	if (!(Opt & TOTALHST_BIT)) sprintf(pok, " -P -O >>");
	else sprintf(pok, " -P -O -K >>");
	sys_call(7, "gmt pstext ", Filet, map, range, optf, pok, Filep);

/* Third, if applicable, plot the histogram of the totaled data */

	/* Top Fig.: preparing map */

	if (!(Opt & TOTALHST_BIT)) return;
	if (!(Opt & TLSCALE_BIT))
		sprintf(map, " -JX%.2f/%.2f", MAPWIDTH, mpheight);
	else
		sprintf(map, " -JX%.2f/%.2f", MAPWIDTH, mpheight*(Ymaxt-Ymin)/(Ymax-Ymin));
	g_xmax_dx(Ymaxt, Ymin, &dyg, &ddyg);
	sprintf(range, " -R%.4g/%.4g/%.4g/%.4g", Xmin, Xmax, Ymin, Ymaxt);
	sprintf(tick," -BWesn+t\"Histograms of %s and %s\" -Bxa%.4gf%.4g -Bya%.4gf%.4g+lFrequency",File1,File2,dxg,ddxg,dyg,ddyg);
	sprintf(pen, " -Wthinnest -Glightgray");

	/* Top Fig.: calculate distribution curves for combined data */

	if (Opt & NORM_BIT) cal_curven_data(Nt, Mxt, Sxt, x0c, dxc);
	if (Opt & LOGNORM_BIT) cal_curvel_data(Nt, Mxlt, Sxlt, x0c, dxc);

	/* Top Fig.: plot a histogram and distribution curves */

	wrt_xy_data(Nfrq, x0, dX, Frqt);
	if (!(Opt & NORM_BIT) && !(Opt & LOGNORM_BIT))
		sys_call(10, "gmt psxy ", Filet, map, range, tick, sbar, pen, shift, pok, Filep);
	else if ((Opt & NORM_BIT) && !(Opt & LOGNORM_BIT)){
		sys_call(10, "gmt psxy ", Filet, map, range, tick, sbar, pen, shift, pok, Filep);
		wrt_xy_data(NFRC, x0c, dxc, Frcn);
		sprintf(pen, " -Wthinner");
		sys_call(7, "gmt psxy ", Filet, map, range, pen, pok, Filep);
	}
	else if (!(Opt & NORM_BIT) && (Opt & LOGNORM_BIT)){
		sys_call(10, "gmt psxy ", Filet, map, range, tick, sbar, pen, shift, pok, Filep);
		wrt_xy_data(NFRC, x0c, dxc, Frcl);
		sprintf(pen, " -Wthinner");
		sys_call(7, "gmt psxy ", Filet, map, range, pen, pok, Filep);
	}
	else {
		sys_call(10, "gmt psxy ", Filet, map, range, tick, sbar, pen, shift, pok, Filep);
		wrt_xy_data(NFRC, x0c, dxc, Frcn);
		sprintf(pen, " -Wthinner");
		sys_call(7, "gmt psxy ", Filet, map, range, pen, pok, Filep);
		wrt_xy_data(NFRC, x0c, dxc, Frcl);
		sprintf(pen, " -Wthin,.");
		sys_call(7, "gmt psxy ", Filet, map, range, pen, pok, Filep);
	}

	/* Top Fig.: write texts and combined data number */

	sprintf(buf, "Combined (N=%d)", Nt);
	wrt_a_text(Xmax-.025*(Xmax-Xmin), Ymaxt-.05*(Ymaxt-Ymin), buf);
	sprintf(pok, " -P -O >>");
	sys_call(7, "gmt pstext ", Filet, map, range, optf, pok, Filep);
}

/* cal_curven_data -- calculate a normal dist curve and stores to Frcn[] */

void cal_curven_data(n, mx, sx, x0, dx0)
int n;
double mx, sx, x0, dx0;
{
	for (i=0; i<NFRC; i++)
		Frcn[i] = n*normdist((x0 + dx0*i - mx)/sx)*dX/sx;
}

/* cal_curvel_data -- calculate a log-normal dist curve and stores to Frcl[] */

void cal_curvel_data(n, mxl, sxl, x0, dx0)
int n;
double mxl, sxl, x0, dx0;
{
	double dum1, dum2;

	for (i=0; i<NFRC; i++){
		if ((dum1 = x0 + dx0*i) <= 0.) Frcl[i] = 0.;
		else {
			dum2 = (log(dum1) - mxl)/sxl;
			Frcl[i] = n*normdist(dum2)*dX/(sxl*dum1);
		}
	}
}

/* wrt_xy_data -- write the curve data starting at x0 for psxy */

void wrt_xy_data(n, x0, dx, data)
int n;
double x0, dx, *data;
{
	if ((fp=fopen(Filet,"w")) == NULL) error("Error of fopen at hst2_hist!");
	for (i=0; i<n; i++)
		fprintf(fp, "%.4g %.4g\n", x0 + dx*i, data[i]);
	fclose(fp);
}

/* wrt_a_text -- write a text data for pstext */

void wrt_a_text(x, y, text)
char *text;
double x, y;
{
	if ((fp=fopen(Filet,"w")) == NULL) error("Error of fopen at hst2_hist!");
	fprintf(fp, "%.4g %.4g %s\n", x, y, text);
	fclose(fp);
}

/* g_xmax_dx -- set up axis parameters */

void g_xmax_dx(xmax, xmin, dx, ddx)
double xmax, xmin, *dx, *ddx;
{
	double span, p=0.;

	span = xmax - xmin;
	while (span >= 10.){
		span /= 10.;
		p += 1.;
	}
	while (span < 1.){
		span *= 10.;
		p -= 1.;
	}
	if (span < 1.2){
		*dx = 0.2*pow(10.,p);   *ddx = 0.1*pow(10.,p);
	}
	else if (span < 3.0){
		*dx = 0.5*pow(10.,p);   *ddx = 0.1*pow(10.,p);
	}
	else if (span < 5.){
		*dx = 1.*pow(10.,p);   *ddx = 0.5*pow(10.,p);
	}
	else if (span < 10.){
		*dx = 2.*pow(10.,p);   *ddx = 1*pow(10.,p);
	}
	else
		error("Error in g_xmax_dx()!");
}
