#include <string.h>
#include "pdemag.h"

#define CNTW0   "$ %s\n"
#define CNTLW   "%8s %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f %4.1f %4.1f %2d %4.0f-%-4.0f\n"
#define CNTLWA  "%8s %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f %4.1f   A  %2d %4.0f-%-4.0f\n"
#define CNTLD   "Range,I,D,Mad,Thd: %.0f-%-.0f %5.1f %5.1f %4.1f %4.1f (Auto off, %s)\n"
#define CNTLDT  "Range,I,D,Mad,Thd: %.0f-%-.0f %5.1f %5.1f %4.1f %4.1f (Madc=%.1f, Excl Org, %s)\n"
#define CNTLDTO "Range,I,D,Mad,Thd: %.0f-%-.0f %5.1f %5.1f %4.1f %4.1f (Madc=%.1f, Incl Org, %s)\n"
#define CNTLDA  "Range,I,D,Mad: %.0f-%-.0f %5.1f %5.1f %4.1f (Auto off, Anchored, %s)\n"
#define CNTLDAT "Range,I,D,Mad: %.0f-%-.0f %5.1f %5.1f %4.1f (Madc=%.1f, Anchored, %s)\n"
#define CNTLS	"Range,I,D: %.0f-%-.0f %5.1f %5.1f (Single step, %s)\n"
#define CNTLNO	"No linear segment determined. (Madc=%.1f, Incl Org, %s)\n"
#define CNTLN	"No linear segment determined. (Madc=%.1f, Excl Org, %s)\n"
#define CNTLNA	"No linear segment determined. (Madc=%.1f, Anchored, %s)\n"
#define CNTGW   "%8s %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f %4.1f   P  %2d %4.0f-%-4.0f\n\
         %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f\n\
         %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f\n"
#define CNTGD   "Range,Ip,Dp,Mad: %.0f-%-.0f %5.1f %5.1f %4.1f (Auto off, %s)\n"
#define CNTGDT  "Range,Ip,Dp,Mad: %.0f-%-.0f %5.1f %5.1f %4.1f (Madc=%.1f, %s)\n"
#define CNTGS	"Range,Ip,Dp: %.0f-%-.0f %5.1f %5.1f (Two steps, %s)\n"
#define CNTGN	"No gtc plane determined. (Madc=%.1f, %s)\n"

extern FILE *Fpw;
extern char Filed[WFILE], Filew[WFILE], **Sampl, *Frame_lbl[];
extern unsigned int Opt, Frame;
extern int Nd, Nstep, Nptr, Nnch, I1, I2;
extern double *Step, **Xs, **Ys, **Zs, Scalzj, Ux[3], Uy[3], Uz[3], Iu[3], Du[3], \
		Madc, Mad, Theta, Ip[3], Dp[3], Ia1[3], Da1[3], Ia2[3], Da2[3];

static int c, i1, i2;

/* pdmg_comd -- returns a first letter of the hitted command */

int pdmg_comd(rem)
char *rem;
{
	fprintf(stdout, "%s ", rem);
	c = get_ch();
	if (c == ZERO) return(-1);
	else if (c == 'q' || c == 'Q') return ZERO;
	else return(c);
}

/* do_init -- called only when the sample is changed */

void do_init(n)
int n;
{
	fprintf(stdout, "%s\n", Sampl[n]);
	Nstep = pdmg_smpldat(n, &I1, &I2);  /* set to I1=0, I2=Nstep-1 */
	pdmg_gmtdat(n);
	pdmg_plot(n);
}

/* go_next */

void go_next(n)
int *n;
{
	if (*n >= Nd -1){
		fprintf(stdout, "End of file!\n");
		return;
	}
	*n += 1;
	do_init(*n);
}

/* go_back -- go back to the previous sample */

void go_back(n)
int *n;
{
	if (*n <= 0){
		fprintf(stdout, "Beginning of file!\n");
		return;
	}
	*n -= 1;
	do_init(*n);
}

/* go_first */

void go_first(n)
int *n;
{
	if (*n <= 0){
		fprintf(stdout, "Beginning of file!\n");
		return;
	}
	*n = 0;
	do_init(*n);
}

/* go_last */

void go_last(n)
int *n;
{
	if (*n >= Nd -1){
		fprintf(stdout, "End of file!\n");
		return;
	}
	*n = Nd - 1;
	do_init(*n);
}

/* core_orient -- change orientation to core frame */

void core_orient(n)
int n;
{
	if (Frame == CORE) return;
	Frame = CORE;
	if (Opt & DRAW_BIT) message_orient();
	pdmg_plot(n);
}

/* situ_orient -- change orientation to core frame */

void situ_orient(n)
int n;
{
	if (Frame == SITU) return;
	Frame = SITU;
	if (Opt & DRAW_BIT) message_orient();
	pdmg_plot(n);
}

/* bed_orient -- change orientation to core frame */

void bed_orient(n)
int n;
{
	if (Frame == TILT) return;
	Frame = TILT;
	if (Opt & DRAW_BIT) message_orient();
	pdmg_plot(n);
}

/* message_orient -- message of the results transferred to the specified orientation */

void message_orient()
{
	if (Opt & LINE_BIT){
		if (Nstep == 1)
			fprintf(stdout, CNTLS, Step[I1], Step[I2], Iu[Frame], Du[Frame], \
				Frame_lbl[Frame]);
		else if (Opt & AUTO_BIT){
			if (!(Opt & ANCHOR_BIT) && (Opt & ORIGIN_BIT))
				fprintf(stdout, CNTLDTO, Step[I1], Step[I2], Iu[Frame], Du[Frame], \
					Mad, Theta, Madc, Frame_lbl[Frame]);
			else if (!(Opt & ANCHOR_BIT) && !(Opt & ORIGIN_BIT))
				fprintf(stdout, CNTLDT, Step[I1], Step[I2], Iu[Frame], Du[Frame], \
					Mad, Theta, Madc, Frame_lbl[Frame]);
			else if ((Opt & ANCHOR_BIT))
				fprintf(stdout, CNTLDAT, Step[I1], Step[I2], Iu[Frame], Du[Frame], \
					Mad, Madc, Frame_lbl[Frame]);
		}
		else {
			if ( !(Opt & ANCHOR_BIT) )
				fprintf(stdout, CNTLD, Step[I1], Step[I2], Iu[Frame], Du[Frame], \
					Mad, Theta, Frame_lbl[Frame]);
			else
				fprintf(stdout, CNTLDA, Step[I1], Step[I2], Iu[Frame], Du[Frame], \
					Mad, Frame_lbl[Frame]);
		}
	}
	else if (Opt & GTC_BIT){
		if (Opt & AUTO_BIT)
			fprintf(stdout, CNTGDT, Step[I1], Step[I2], Ip[Frame], Dp[Frame], \
				Mad, Madc, Frame_lbl[Frame]);
		else
			fprintf(stdout, CNTGD, Step[I1], Step[I2], Ip[Frame], Dp[Frame], \
				Mad, Frame_lbl[Frame]);
	}
}

/* do_pcaline -- linear regression by Principal Component Analysis */

void do_pcaline(n)
int n;
{
	double xb, yb, zb, dumm;

	if ( !(Opt & ZJ_TOP_BIT) ){
		Opt &= ~EQ_TOP_BIT;   Opt |= ZJ_TOP_BIT;
	}
	Opt &= ~GTC_BIT;   Opt |= LINE_BIT;
	I1 = 0;  I2 = Nstep-1;
	if (Nstep == 1){
		Opt |= DRAW_BIT;  Mad = -1.;  Theta = -1.;
		xb=Ux[Frame]=Xs[Frame][I1]; yb=Uy[Frame]=Ys[Frame][I1]; zb=Uz[Frame]=Zs[Frame][I1];
		carmag(Ux[Frame], Uy[Frame], Uz[Frame], &dumm, Iu+Frame, Du+Frame);
		set_zjpcaline(Frame, xb, yb, zb, Ux[Frame], Uy[Frame], Uz[Frame]);
		if (Frame==SITU) situ_coretilt(n, xb, yb, zb, Ux[Frame], Uy[Frame], Uz[Frame]);
		else if (Frame==CORE) core_situtilt(n, xb, yb, zb, Ux[Frame], Uy[Frame], Uz[Frame]);
		else if (Frame==TILT) tilt_coresitu(n, xb, yb, zb, Ux[Frame], Uy[Frame], Uz[Frame]);
		fprintf(stdout, CNTLS, Step[I1], Step[I2], Iu[Frame], Du[Frame], Frame_lbl[Frame]);
	}
	else if (Opt & AUTO_BIT){
		if (pdmg_linea(n) != ZERO) {
			Opt |= DRAW_BIT;
			if (!(Opt & ANCHOR_BIT) && (Opt & ORIGIN_BIT))
				fprintf(stdout, CNTLDTO, Step[I1], Step[I2], Iu[Frame], Du[Frame], \
					Mad, Theta, Madc, Frame_lbl[Frame]);
			else if (!(Opt & ANCHOR_BIT) && !(Opt & ORIGIN_BIT))
				fprintf(stdout, CNTLDT, Step[I1], Step[I2], Iu[Frame], Du[Frame], \
					Mad, Theta, Madc, Frame_lbl[Frame]);
			else if ((Opt & ANCHOR_BIT))
				fprintf(stdout, CNTLDAT, Step[I1], Step[I2], Iu[Frame], Du[Frame], \
					Mad, Madc, Frame_lbl[Frame]);
		}
		else {
			Opt &= ~DRAW_BIT;
			I1 = 0;  I2 = Nstep-1;
			if (!(Opt & ANCHOR_BIT) && (Opt & ORIGIN_BIT))
				fprintf(stdout, CNTLNO, Madc, Frame_lbl[Frame]);
			else if (!(Opt & ANCHOR_BIT) && !(Opt & ORIGIN_BIT))
				fprintf(stdout, CNTLN, Madc, Frame_lbl[Frame]);
			else if ((Opt & ANCHOR_BIT))
				fprintf(stdout, CNTLNA, Madc, Frame_lbl[Frame]);
		}
	}
	else {
		Opt &= ~DRAW_BIT;
		pdmg_plot(n);
		fprintf(stdout, "(Auto off) %2d-%2d: ", 0, Nstep-1);
		while ((c = inpi("i1,i2? ", 2, &i1, &i2)) != ZERO){
			if (c == -1) continue;
			if (i1 >= 0 && i2 < Nstep && i2 - i1 >= 0) break;
		}
		if (c == ZERO){
			Opt &= ~LINE_BIT;
			return;
		}
		I1 = i1;   I2 = i2;
		pdmg_line(n);
		if ( !(Opt & ANCHOR_BIT) )
			fprintf(stdout, CNTLD, Step[I1], Step[I2], Iu[Frame], Du[Frame], \
				Mad, Theta, Frame_lbl[Frame]);
		else
			fprintf(stdout, CNTLDA, Step[I1], Step[I2], Iu[Frame], Du[Frame], \
				Mad, Frame_lbl[Frame]);
		Opt |= DRAW_BIT;
	}
	pdmg_plot(n);
	if (I2-I1+1 == 1) Opt &= ~ANCHOR_BIT;
}

/* do_pcagtc -- GTC analysis by principal component principle */

void do_pcagtc(n)
int n;
{
	I1 = 0;  I2 = Nstep-1;
	if (Nstep == 1){
		fprintf(stdout, "No gtc plane for a single step data!\n");
		return;
	}
	if ( !(Opt & EQ_TOP_BIT) ){
		Opt &= ~ZJ_TOP_BIT;   Opt |= EQ_TOP_BIT;
	}
	Opt &= ~LINE_BIT;   Opt |= GTC_BIT;
	if (Nstep == 2){
		pdmg_gtc(n);
		fprintf(stdout, CNTGS, Step[I1], Step[I2], Ip[Frame], Dp[Frame], Frame_lbl[Frame]);
		Opt |= DRAW_BIT;
	}
	else if (Opt & AUTO_BIT){
		if (pdmg_gtca(n) != ZERO){
			Opt |= DRAW_BIT;
			fprintf(stdout, CNTGDT, Step[I1], Step[I2], Ip[Frame], Dp[Frame], \
				Mad, Madc, Frame_lbl[Frame]);
		}
		else {
			Opt &= ~DRAW_BIT;
			I1 = 0;  I2 = Nstep-1;
			fprintf(stdout, CNTGN, Madc, Frame_lbl[Frame]);
		}
	}
	else {
		Opt &= ~DRAW_BIT;
		pdmg_plot(n);
		fprintf(stdout, "(Auto off) %2d-%2d: ", 0, Nstep-1);
		while ((c = inpi("i1,i2? ", 2, &i1, &i2)) != ZERO){
			if (c == -1) continue;
			if (i1 >= 0 && i2 < Nstep && i2 - i1 >= 1) break;
		}
		if (c == ZERO) return;
		I1 = i1;   I2 = i2;
		pdmg_gtc(n);
		fprintf(stdout, CNTGD, Step[I1], Step[I2], Ip[Frame], Dp[Frame], Mad, \
			Frame_lbl[Frame]);
		Opt |= DRAW_BIT;
	}
	pdmg_plot(n);
}

/* critical_mad -- read Madc for automatic PCA */

void critical_mad(n)
int n;
{
	fprintf(stdout, "Madc=%.1f: ", Madc);
	while ((c=inpd("new Madc? ", 1, &Madc)) != ZERO){
		if (c == -1) continue;
		if (Madc > 0.) break;
	}
	if (c == ZERO) return;
	Opt |= AUTO_BIT;
	if (Opt & LINE_BIT)
		do_pcaline(n);
	else if (Opt & GTC_BIT)
		do_pcagtc(n);
}

/* set_pcaorigin -- ON & OFF of inclusion of origin into PCA analysis */

void set_pcaorigin(n)
int n;
{
	if (Nstep == 1)
		fprintf(stdout, "Single step direction is always anchored to the origin!\n");
	else if ((Opt & LINE_BIT) && (Opt & AUTO_BIT)){
		if (!(Opt & ANCHOR_BIT)){
			if (Opt & ORIGIN_BIT){
				if (Nstep > 2){
					Opt &= ~ORIGIN_BIT;
					fprintf(stdout, "Line-PCA: Origin excluded.\n");
				}
				else
					fprintf(stdout, "Two steps can not exclude origin!\n");
			}
			else {
				Opt |= ORIGIN_BIT;
				fprintf(stdout, "Line-PCA: Origin included.\n");
			}
			do_pcaline(n);
		}
		else
			fprintf(stdout, "First hit \"A\" to cancel Anchored!\n");
	}
	else if ((Opt & LINE_BIT) && !(Opt & AUTO_BIT))
		fprintf(stdout, "Origin is excluded for manual line PCA analysis!\n");
	else if (Opt & GTC_BIT)
		fprintf(stdout, "GTC is always anchored to the origin!\n");
}

/* anchor_origin -- ON & OFF of anchored regression line on Zj-plot of NRM steps */

void anchor_origin(n)
int n;
{
	if (Nstep == 1)
		fprintf(stdout, "Single step direction is always anchored to the origin!\n");
	else if (Opt & LINE_BIT){
		if (Opt & ANCHOR_BIT){
			Opt &= ~ANCHOR_BIT;
			Opt |= ORIGIN_BIT;
		}
		else {
			Opt |= ANCHOR_BIT;
			Opt &= ~ORIGIN_BIT;
		}
		do_pcaline(n);
	}
	else if (Opt & GTC_BIT)
		fprintf(stdout, "GTC is always anchored to the origin!\n");
}

/* set_pcaauto -- ON & OFF of automatic PCA analysis*/

void set_pcaauto(n)
int n;
{
	if (Opt & AUTO_BIT){
		Opt &= ~AUTO_BIT;  Opt &= ~ANCHOR_BIT;
	}
	else {
		Opt |= AUTO_BIT;  Opt &= ~ANCHOR_BIT;  Opt |= ORIGIN_BIT;
	}
	if(Opt & LINE_BIT)
		do_pcaline(n);
	else if (Opt & GTC_BIT)
		do_pcagtc(n);
	else {
		if (Opt & AUTO_BIT)
			fprintf(stdout, "au\"T\"o analysis was turned ON.\n");
		else
			fprintf(stdout, "au\"T\"o analysis was turned OFF.\n");
	}
}

/* delete_results -- delete the results of PCA-line or PCA-GTC analysis */

void delete_results(n)
int n;
{
	if (Opt & DRAW_BIT){
		if (Opt & LINE_BIT)
			Opt &= ~LINE_BIT;
		else if (Opt & GTC_BIT)
			Opt &= ~GTC_BIT;
		Opt &= ~ANCHOR_BIT;
		Opt &= ~DRAW_BIT;
		I1 = 0;   I2 = Nstep - 1;
		pdmg_plot(n);
	}
}

/* write_results -- write the PCA or GTC results into a specified file */

void write_results(n)
int n;
{
	if (!(Opt & LINE_BIT) && !(Opt & GTC_BIT)){
		fprintf(stdout, "Analyze first!\n");
		return;
	}
	if (!(Opt & WRT_FILE_BIT)){
		while ((c=inpstr("Output file?",Filew,WFILE)) != ZERO){
			if (strcmp(Filew, Filed) == 0){
				fprintf(stdout, "Name other than now input file \"%s\"!\n", Filed);
				continue;
			}
			if ((Fpw=fopen(Filew,"r")) != NULL){
				fclose(Fpw);
				if ((Fpw=fopen(Filew,"a")) != NULL){
					fprintf(stdout, "An old file %s is opened to append.\n", Filew);
					if (yorn("OK? (Y or Rtn/N)",1) != 1){
						fclose(Fpw);
						continue;
					}
					break;
				}
				else
					error("Error of open an old file!");
			}
			else {
				if ((Fpw=fopen(Filew,"w")) != NULL){
					fprintf(stdout, "A new file %s is opened.\n", Filew);
					break;
				}
				else
					error("Error of open a new file!");
			}
		}
		if (c == ZERO) return;
		fprintf(Fpw, CNTW0, Filed);
		Opt |= WRT_FILE_BIT;
	}
	else {
		if ((Fpw=fopen(Filew,"a")) == NULL)
			error("Error of an existing file!");
	}
	if ((Nstep==1) || (I2-I1+1==1)){
		fprintf(Fpw, CNTLWA, Sampl[n], Iu[0], Du[0], Iu[1], Du[1], Iu[2], Du[2], \
			Mad, I2-I1+1, Step[I1], Step[I2]);
		fclose(Fpw);
		fprintf(stdout, "Single step direction were written to %s.\n", Filew);
	}
	else if (Opt & LINE_BIT){
		if ( !(Opt & ANCHOR_BIT) )
			fprintf(Fpw, CNTLW, Sampl[n], Iu[0], Du[0], Iu[1], Du[1], Iu[2], Du[2], \
				Mad, Theta, I2-I1+1, Step[I1], Step[I2]);
		else
			fprintf(Fpw, CNTLWA, Sampl[n], Iu[0], Du[0], Iu[1], Du[1], Iu[2], Du[2], \
				Mad, I2-I1+1, Step[I1], Step[I2]);
		fclose(Fpw);
		fprintf(stdout, "PCA line results were written to %s.\n", Filew);
	}
	else if (Opt & GTC_BIT){
		fprintf(Fpw, CNTGW, Sampl[n], Ip[0], Dp[0], Ia1[0], Da1[0], Ia2[0], Da2[0], Mad, \
			I2-I1+1, Step[I1], Step[I2], Ip[1], Dp[1], Ia1[1], Da1[1], Ia2[1], Da2[1], \
			Ip[2], Dp[2], Ia1[2], Da1[2], Ia2[2], Da2[2]);
		fclose(Fpw);
		fprintf(stdout, "GTC results were written to %s.\n", Filew);
	}
	else
		error("Error of Opt in write_results()!");
}

/* out_psfile -- copy the present plot to a specified file */

void out_psfile(n)
int n;
{
	char fileps[100];

	while ((c=inpstr("PS file?",fileps,WFILE)) != ZERO){
		if (strcmp(fileps,FILEP) == 0){
			fprintf(stdout, "Name other than the reserved file \"%s\"!\n", FILEP);
			continue;
		}
		if (fopen(fileps,"r") != NULL)
			if (yorn("File exists. Overwrite? (Y or Rtn/N)",+1) != 1)
				continue;
		sys_call(4, "cp -f ", FILEP, " ", fileps);
		break;
	}
}

/* enlarge_scale -- plot the Zijderveld diagram in larger scale, works for the present sample */

void enlarge_scale(n)
int n;
{
	double d;

	while ((c = inpd("Scale?(to NRM) ", 1, &d)) != ZERO){
		if (c == -1) continue;
		if (d < 0.001 || d > 1000.) continue;
		Scalzj = d;
		break;
	}
	if (c == ZERO) return;
	pdmg_plot(n);
}

/* put_annot -- put or change annotations from none, Temp., No. each time called. */

void put_annot(n)
int n;
{
	if (Opt & STEP_BIT){
		Opt &= ~STEP_BIT;
		Opt |= NUMBER_BIT;
	}
	else if (Opt & NUMBER_BIT){
		Opt &= ~NUMBER_BIT;
	}
	else
		Opt |= STEP_BIT;
	pdmg_plot(n);
}

/* change_eq -- chnage to equal area plot */

void change_eq(n)
int n;
{
	if (Opt & ZJ_TOP_BIT){
		Opt &= ~ZJ_TOP_BIT;
		Opt |= EQ_TOP_BIT;
		pdmg_plot(n);
	}
	else
		;
}

/* change_zj -- chnage to Zijderveld plot */

void change_zj(n)
int n;
{
	if (Opt & EQ_TOP_BIT){
		Opt &= ~EQ_TOP_BIT;
		Opt |= ZJ_TOP_BIT;
		pdmg_plot(n);
	}
	else
		;
}
#undef CNTW0
#undef CNTLW
#undef CNTLWA
#undef CNTLD
#undef CNTLDT
#undef CNTLDTO
#undef CNTLDA
#undef CNTLDAT
#undef CNTLS
#undef CNTLNO
#undef CNTLN
#undef CNTLNA
#undef CNTGW
#undef CNTGD
#undef CNTGDT
#undef CNTGS
#undef CNTGN
