#include <string.h>
#include "pdemag.h"

#define TICKEQ  " -Bg90"
#define RANGEQ " -R0/360/0/90"
#define CONT	"%.1f %.1f\n"
#define NGTC	12
#define TXEG  "-0.5 2.4 10p,Helvetica,black RB Range: %.0f-%-.0f\n\
-0.5 1.8 10p,Helvetica,black RB Incp= %5.1f\n\
-0.5 1.2 10p,Helvetica,black RB Decp= %5.1f\n\
-0.5 0.6 10p,Helvetica,black RB MAD= %5.1f\n\
-0.5 0.0 10p,Helvetica,black RB (Madc=%3.1f)\n"
#define TXEGO "-0.5 2.4 10p,Helvetica,black RB Range: %.0f-%-.0f\n\
-0.5 1.8 10p,Helvetica,black RB Incp= %5.1f\n\
-0.5 1.2 10p,Helvetica,black RB Decp= %5.1f\n\
-0.5 0.6 10p,Helvetica,black RB MAD= %5.1f\n\
-0.5 0.0 10p,Helvetica,black RB (Auto Off)\n"

extern char *Frame_lbl[], *Mapeq[], *Maptxt[], *Texteq[], *Cstep[], *Cstepg[], *Cnumb[], *Cnumbg[],\
	*Circs[], *Circsg[], *Circo[], *Circog[], *Dshift[], *Cross[], *Crossd[], Sdum[LSIZ_COM];
extern unsigned int Opt, Frame;
extern int Nstep, I1, I2, *Ida;
extern double *Step, **Ieq, **Deq, **Ieqr, Ip[3], Dp[3], Mad, Madc, Ia1[3], Da1[3], Ia2[3], Da2[3];

static double incg[NGTC+1], decg[NGTC+1], incgr[NGTC+1];

/* pdmg_eq -- equal area plot of remanence vectors
	args: f -- frame number, s -- size number, xy -- GMT X & Y option
*/

void pdmg_eq(f, s, xy)
int f, s;
char *xy;
{
	/* basemap */

	sys_call(7, "gmt psbasemap", Mapeq[s], TICKEQ, RANGEQ, xy, " -P -O -K >>", FILEP);

	/* draw a great circle if applicable */

	if ((Opt & GTC_BIT) && (Opt & DRAW_BIT)){
		set_gtc_circ(f);
		wrt_tmp2(0, NGTC, CONT, decg, incg);
		sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, PEN3S, " -P -O -K >>", FILEP);
		wrt_tmp2(0, NGTC, CONT, decg, incgr);
		sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, PEN3D, " -P -O -K >>", FILEP);
		if (Ia1[f] >= 0.){
			sprintf(Sdum, CONT, 360. - Da1[f], Ia1[f]);
			wrt_tmp();
			sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, Cross[s], \
				" -P -O -K >>", FILEP);
		}
		else {
			sprintf(Sdum, CONT, 360. - Da1[f], -Ia1[f]);
			wrt_tmp();
			sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, Crossd[s], \
				" -P -O -K >>", FILEP);
		}
		if (Ia2[f] >= 0.){
			sprintf(Sdum, CONT, 360. - Da2[f], Ia2[f]);
			wrt_tmp();
			sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, Cross[s], \
			" -P -O -K >>", FILEP);
		}
		else {
			sprintf(Sdum, CONT, 360. - Da2[f], -Ia2[f]);
			wrt_tmp();
			sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, Crossd[s], \
				" -P -O -K >>", FILEP);
		}
	}

	/* plot dimmed for the range outside of I1 and I2 */

	if (I1 > 0){
		wrt_tmp2(0, I1, CONT, Deq[f], Ieq[f]);
		sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, PEN3SG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, Circsg[s], " -P -O -K >>", FILEP);
		wrt_tmp2(0, I1, CONT, Deq[f], Ieqr[f]);
		sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, PEN3DG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, Circog[s], " -P -O -K >>", FILEP);
		if (s != LARGE){
			wrt_tmp3(0, 0, Cstepg[s], Deq[f], Ieq[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
			wrt_tmp3(0, 0, Cstepg[s], Deq[f], Ieqr[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
		}
		else {
			if (Opt & STEP_BIT){
				wrt_tmp3(0, I1, Cstepg[s], Deq[f], Ieq[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
				wrt_tmp3(0, I1, Cstepg[s], Deq[f], Ieqr[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
			}
			else if (Opt & NUMBER_BIT){
				wrt_tmp3i(0, I1, Cnumbg[s], Deq[f], Ieq[f], Ida);
				sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
				wrt_tmp3i(0, I1, Cnumbg[s], Deq[f], Ieqr[f], Ida);
				sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
			}
			else {
				wrt_tmp3(0, 0, Cstepg[s], Deq[f], Ieq[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
				wrt_tmp3(0, 0, Cstepg[s], Deq[f], Ieqr[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
			}
		}
	}
	if (I2 < Nstep-1){
		wrt_tmp2(I2, Nstep-1, CONT, Deq[f], Ieq[f]);
		sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, PEN3SG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, Circsg[s], " -P -O -K >>", FILEP);
		wrt_tmp2(I2, Nstep-1, CONT, Deq[f], Ieqr[f]);
		sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, PEN3DG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, Circog[s], " -P -O -K >>", FILEP);
		if (s == LARGE) {
			if (Opt & STEP_BIT){
				wrt_tmp3(I2, Nstep-1, Cstepg[s], Deq[f], Ieq[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
				wrt_tmp3(I2, Nstep-1, Cstepg[s], Deq[f], Ieqr[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
			}
			else if (Opt & NUMBER_BIT){
				wrt_tmp3i(I2, Nstep-1, Cnumbg[s], Deq[f], Ieq[f], Ida);
				sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
				wrt_tmp3i(I2, Nstep-1, Cnumbg[s], Deq[f], Ieqr[f], Ida);
				sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
			}
			else {
				wrt_tmp3(Nstep-1, Nstep-1, Cstepg[s], Deq[f], Ieq[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
				wrt_tmp3(Nstep-1, Nstep-1, Cstepg[s], Deq[f], Ieqr[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
			}
		}
	}

	/* plot solid circles for the range between I1 and I2 */

	wrt_tmp2(I1, I2, CONT, Deq[f], Ieq[f]);
	sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, PEN3S, " -P -O -K >>", FILEP);
	sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, Circs[s], " -P -O -K >>", FILEP);
	wrt_tmp2(I1, I2, CONT, Deq[f], Ieqr[f]);
	sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, PEN3D, " -P -O -K >>", FILEP);
	sys_call(7, "gmt psxy ", FILET, Mapeq[s], RANGEQ, Circo[s], " -P -O -K >>", FILEP);
	if (s != LARGE){
		wrt_tmp3(I1, I1, Cstep[s], Deq[f], Ieq[f], Step);
		sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, Dshift[s], \
			" -P -O -K >>", FILEP);
		wrt_tmp3(I1, I1, Cstep[s], Deq[f], Ieqr[f], Step);
		sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, Dshift[s], \
			" -P -O -K >>", FILEP);
		wrt_tmp3(I2, I2, Cstep[s], Deq[f], Ieq[f], Step);
		sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, Dshift[s], \
			" -P -O -K >>", FILEP);
		wrt_tmp3(I2, I2, Cstep[s], Deq[f], Ieqr[f], Step);
		sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, Dshift[s], \
			" -P -O -K >>", FILEP);
	}
	else {
		if (Opt & STEP_BIT){
			wrt_tmp3(I1, I2, Cstep[s], Deq[f], Ieq[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
			wrt_tmp3(I1, I2, Cstep[s], Deq[f], Ieqr[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
		}
		else if (Opt & NUMBER_BIT){
			wrt_tmp3i(I1, I2, Cnumb[s], Deq[f], Ieq[f], Ida);
			sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
			wrt_tmp3i(I1, I2, Cstep[s], Deq[f], Ieqr[f], Ida);
			sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
		}
		else {
			wrt_tmp3(I1, I1, Cstep[s], Deq[f], Ieq[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
			wrt_tmp3(I1, I1, Cstep[s], Deq[f], Ieqr[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
			wrt_tmp3(I2, I2, Cstep[s], Deq[f], Ieq[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
			wrt_tmp3(I2, I2, Cstep[s], Deq[f], Ieqr[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapeq[s], RANGEQ, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
		}
	}

	/* plot texts */

	sprintf(Sdum, Texteq[s], Frame_lbl[f]);
	wrt_tmp();
	sys_call(6, "gmt pstext ", FILET, Maptxt[s], OPTF, " -N -P -O -K >>", FILEP);
	if ( (s == LARGE) && (Opt & GTC_BIT) && (Opt & DRAW_BIT)){
		if (Opt & AUTO_BIT){
			sprintf(Sdum, TXEG, Step[I1], Step[I2], Ip[Frame], Dp[Frame], Mad, Madc);
			wrt_tmp();
		}
		else {
			sprintf(Sdum, TXEGO, Step[I1], Step[I2], Ip[Frame], Dp[Frame], Mad);
			wrt_tmp();
		}
		sys_call(6, "gmt pstext ", FILET, Maptxt[2], OPTF, " -N -P -O -K >>", FILEP);
	}
}

/* draw_gtc_circ */

void set_gtc_circ(f)
int f;
{
	int i;
	double dec0 = 0., ddec0, alph, beta, inc1, dec1, inc, dec;

	ddec0 = 360./NGTC;
	alph = 90. - Dp[f];   beta = 90. + Ip[f];
	for (i = 0; i <= NGTC; i++){
		rotuvec(alph, beta, 0., dec0, &inc1, &dec1);
		rotuvec(-alph, 0., inc1, dec1, &inc, &dec);
		checklon(&dec, 0);
		incg[i] = inc;   decg[i] = 360. - dec;   incgr[i] = -inc;
		dec0 += ddec0;
	}
}
#undef TICKEQ
#undef RANGEQ
#undef CONT
#undef NGTC
#undef TXEG
#undef TXEGO
