/* pdmg_smpldat -- calculate remanence vectors for (i+1)th sample
	Args & return:
		i1, i2 -- range of regression I1 & I2
		Return -- number of steps
	Internal variables:
		j -- (j+1)th line of data series
		k -- kth step (0th indicates step 00 or 20)
*/

#include <stdlib.h>
#include "pdemag.h"

extern char **Sampl, **Stepd;
extern int *Idsmpl;
extern double *Azim, *Plun, *Strik, *Dip, *Magd, *Incd, *Decd, *Chid, *Step, Stepmax, *Mag, *Chi, \
		**Is, **Ds, **Xs, **Ys, **Zs;

int pdmg_smpldat(i, i1, i2)
int i, *i1, *i2;
{
	int j, k;
	double dumm, dumx, dumy, dumz;

	j = Idsmpl[i];   k = 0;
	while (j < Idsmpl[i+1]){
		Step[k] = atof(Stepd[j]);
		Mag[k] = Magd[j];   Is[0][k] = Incd[j];   Ds[0][k] = Decd[j];
		magcar(Mag[k], Is[0][k], Ds[0][k], &Xs[0][k], &Ys[0][k], &Zs[0][k]);
		Chi[k] = Chid[j];
		core(Azim[i], Plun[i], Xs[0][k], Ys[0][k], Zs[0][k], &Xs[1][k], &Ys[1][k], &Zs[1][k]);
		carmag(Xs[1][k], Ys[1][k], Zs[1][k], &dumm, &Is[1][k], &Ds[1][k]);
		rotvec(-Strik[i], -Dip[i], Xs[1][k], Ys[1][k], Zs[1][k], &dumx, &dumy, &dumz);
		rotvec(Strik[i], 0., dumx, dumy, dumz, &Xs[2][k], &Ys[2][k], &Zs[2][k]);
		carmag(Xs[2][k], Ys[2][k], Zs[2][k], &dumm, &Is[2][k], &Ds[2][k]);
		k++;   j++;
	}
	*i1 = 0;   *i2 = k - 1;
	maxmin(k, Step, &Stepmax, &dumm);
	return(k);
}
