#include <math.h>
#include <string.h>
#include "pdemag.h"

#define TICKZJ   " -Bf10"
#define CONT	"%.4f %.4f\n"
#define CLBL	"%.4f %.4f 10p,Helvetica,black RB X\n%.4f %.4f 10p,Helvetica,black LB Y\n\
%.4f %.4f 10p,Helvetica,black RB Z\n"
#define CTCKX	"%.4f %.4f 10p,Helvetica,black BC %.0f\n"
#define CTCKXF	"%.4f %.4f 10p,Helvetica,black BC %.1f\n"
#define CTCKY	"%.4f %.4f 10p,Helvetica,black MR %.0f\n"
#define CTCKYF	"%.4f %.4f 10p,Helvetica,black MR %.1f\n"
#define TXZLI	"-0.5 3.6 10p,Helvetica,black RB Range: %.0f-%-.0f\n\
-0.5 3.0 10p,Helvetica,black RB Inc= %5.1f\n\
-0.5 2.4 10p,Helvetica,black RB Dec= %5.1f\n\
-0.5 1.8 10p,Helvetica,black RB MAD= %5.1f\n\
-0.5 1.2 10p,Helvetica,black RB Thd= %5.1f\n\
-0.5 0.6 10p,Helvetica,black RB (Madc=%3.1f)\n\
-0.5 0.0 10p,Helvetica,black RB (Incl Org)\n"
#define TXZLE	"-0.5 3.6 10p,Helvetica,black RB Range: %.0f-%-.0f\n\
-0.5 3.0 10p,Helvetica,black RB Inc= %5.1f\n\
-0.5 2.4 10p,Helvetica,black RB Dec= %5.1f\n\
-0.5 1.8 10p,Helvetica,black RB MAD= %5.1f\n\
-0.5 1.2 10p,Helvetica,black RB Thd= %5.1f\n\
-0.5 0.6 10p,Helvetica,black RB (Madc=%3.1f)\n\
-0.5 0.0 10p,Helvetica,black RB (Excl Org)\n"
#define TXZLA	"-0.5 3.0 10p,Helvetica,black RB Range: %.0f-%-.0f\n\
-0.5 2.4 10p,Helvetica,black RB Inc= %5.1f\n\
-0.5 1.8 10p,Helvetica,black RB Dec= %5.1f\n\
-0.5 1.2 10p,Helvetica,black RB MAD= %5.1f\n\
-0.5 0.6 10p,Helvetica,black RB (Madc=%3.1f)\n\
-0.5 0.0 10p,Helvetica,black RB (Anchored)\n"
#define TXZLO	"-0.5 3.0 10p,Helvetica,black RB Range: %.0f-%-.0f\n\
-0.5 2.4 10p,Helvetica,black RB Inc= %5.1f\n\
-0.5 1.8 10p,Helvetica,black RB Dec= %5.1f\n\
-0.5 1.2 10p,Helvetica,black RB MAD= %5.1f\n\
-0.5 0.6 10p,Helvetica,black RB Thd= %5.1f\n\
-0.5 0.0 10p,Helvetica,black RB (Auto Off)\n"
#define TXZLOA	"-0.5 3.0 10p,Helvetica,black RB Range: %.0f-%-.0f\n\
-0.5 2.4 10p,Helvetica,black RB Inc= %5.1f\n\
-0.5 1.8 10p,Helvetica,black RB Dec= %5.1f\n\
-0.5 1.2 10p,Helvetica,black RB MAD= %5.1f\n\
-0.5 0.6 10p,Helvetica,black RB (Auto Off)\n\
-0.5 0.0 10p,Helvetica,black RB (Anchored)\n"

extern char *Frame_lbl[], *Mapzj[], *Maptxt[], *Textzj[], *Cstep[], *Cstepg[], *Cnumb[], *Cnumbg[],\
		*Circs[], *Circsg[], *Circo[], *Circog[], *Dshift[], Sdum[LSIZ_COM];
extern unsigned int Opt, Frame;
extern int Nstep, I1, I2, *Ida;
extern double *Step, *Mag, Xzj1[3], Xzj2[3], Yzj1[3], Yzj2[3], Yzjyr1[3], Yzjyr2[3], Yzjzr1[3], \
		Yzjzr2[3], Gapzj[3], dXzj[3], **Xzj, **Yzj, **Zzj, Scalzj, Iu[3], Du[3], \
		Mad, Madc, Theta;

static char Range[100];

/* pdmg_zj -- plot a Zijderveld diagram.
	args: f -- frame number, s -- size number, xy -- GMT X & Y option
	UPDATE: modified to meet with GMT5.1.2 & recent gcc.   031918
*/

void pdmg_zj(f, s, xy)
int f, s;
char *xy;
{
	/* axis & tick */

	sprintf(Range, " -R%.2f/%.2f/%.2f/%.2f", 
		Xzj1[f]*Scalzj, Xzj2[f]*Scalzj, Yzj1[f]*Scalzj, Yzj2[f]*Scalzj);
	sprintf(Sdum, "%.2f 0\n%.2f 0\n", Xzj1[f], Xzj2[f]);
	wrt_tmp();
	sys_call(9, "gmt psxy ", FILET, Mapzj[s], Range, TICKZJ, PEN2S, xy, " -P -O -K >>", FILEP);
	sprintf(Sdum, "0 %.2f\n0 %.2f\n", Yzj1[f], Yzj2[f]);
	wrt_tmp();
	sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, PEN2S, " -P -O -K >>", FILEP);
	sprintf(Sdum, CLBL, Xzj2[f]-Gapzj[f], -Gapzj[f], Gapzj[f], Yzj2[f]-Gapzj[f], -Gapzj[f], \
		Yzj2[f]-Gapzj[f]);
	wrt_tmp();
	sys_call(7, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, " -N -P -O -K >>", FILEP);
	if (Xzj1[f] < -dXzj[f]) draw_tickx(s, -dXzj[f], Gapzj[f]);
	if (Xzj2[f] > dXzj[f]) draw_tickx(s, dXzj[f], Gapzj[f]);
	if (Yzj1[f] < -dXzj[f]) draw_ticky(s, -dXzj[f], Gapzj[f]);
	if (Yzj2[f] > dXzj[f]) draw_ticky(s, dXzj[f], Gapzj[f]);

	/* plot a regression line if applicable */

	if ((Opt & LINE_BIT) && (Opt & DRAW_BIT)){
		sprintf(Sdum, "%.4f %.4f\n%.4f %.4f\n", Xzj1[f], Yzjyr1[f], Xzj2[f], Yzjyr2[f]);
		wrt_tmp();
		sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, PEN3D, " -P -O -K >>", FILEP);
		sprintf(Sdum, "%.4f %.4f\n%.4f %.4f\n", Xzj1[f], Yzjzr1[f], Xzj2[f], Yzjzr2[f]);
		wrt_tmp();
		sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, PEN3D, " -P -O -K >>", FILEP);
	}

	/* plot data dimmed for outside of I1 & I2 */

	if (I1 > 0){
		wrt_tmp2(0, I1, CONT, Xzj[f], Yzj[f]);
		sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, PEN3SG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, Circsg[s], " -P -O -K >>", FILEP);
		wrt_tmp2(0, I1, CONT, Xzj[f], Zzj[f]);
		sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, PEN3DG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, Circog[s], " -P -O -K >>", FILEP);
		if (s != LARGE){
			wrt_tmp3(0, 0, Cstepg[s], Xzj[f], Yzj[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
			wrt_tmp3(0, 0, Cstepg[s], Xzj[f], Zzj[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
		}
		else {
			if (Opt & STEP_BIT){
				wrt_tmp3(0, I1, Cstepg[s], Xzj[f], Yzj[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
				wrt_tmp3(0, I1, Cstepg[s], Xzj[f], Zzj[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
			}
			else if (Opt & NUMBER_BIT){
				wrt_tmp3i(0, I1, Cnumbg[s], Xzj[f], Yzj[f], Ida);
				sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
				wrt_tmp3i(0, I1, Cnumbg[s], Xzj[f], Zzj[f], Ida);
				sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
			}
			else {
				wrt_tmp3(0, 0, Cstepg[s], Xzj[f], Yzj[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
				wrt_tmp3(0, 0, Cstepg[s], Xzj[f], Zzj[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
			}
		}
	}
	
	if (I2 < Nstep-1){
		wrt_tmp2(I2, Nstep-1, CONT, Xzj[f], Yzj[f]);
		sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, PEN3SG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, Circsg[s], " -P -O -K >>", FILEP);
		wrt_tmp2(I2, Nstep-1, CONT, Xzj[f], Zzj[f]);
		sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, PEN3DG, " -P -O -K >>", FILEP);
		sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, Circog[s], " -P -O -K >>", FILEP);
		if (s == LARGE) {
			if (Opt & STEP_BIT){
				wrt_tmp3(I2, Nstep-1, Cstepg[s], Xzj[f], Yzj[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
				wrt_tmp3(I2, Nstep-1, Cstepg[s], Xzj[f], Zzj[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
			}
			else if (Opt & NUMBER_BIT){
				wrt_tmp3i(I2, Nstep-1, Cnumbg[s], Xzj[f], Yzj[f], Ida);
				sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
				wrt_tmp3i(I2, Nstep-1, Cnumbg[s], Xzj[f], Zzj[f], Ida);
				sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
			}
			else {
				wrt_tmp3(Nstep-1, Nstep-1, Cstepg[s], Xzj[f], Yzj[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
				wrt_tmp3(Nstep-1, Nstep-1, Cstepg[s], Xzj[f], Zzj[f], Step);
				sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, \
					Dshift[s], " -P -O -K >>", FILEP);
			}
		}
	}

	/* plot data solid between I1 and I2 */

	wrt_tmp2(I1, I2, CONT, Xzj[f], Yzj[f]);
	sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, PEN3S, " -P -O -K >>", FILEP);
	sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, Circs[s], " -P -O -K >>", FILEP);
	wrt_tmp2(I1, I2, CONT, Xzj[f], Zzj[f]);
	sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, PEN3D, " -P -O -K >>", FILEP);
	sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, Circo[s], " -P -O -K >>", FILEP);
	if (s != LARGE){
		wrt_tmp3(I1, I1, Cstep[s], Xzj[f], Yzj[f], Step);
		sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, Dshift[s], \
			" -P -O -K >>", FILEP);
		wrt_tmp3(I1, I1, Cstep[s], Xzj[f], Zzj[f], Step);
		sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, Dshift[s], \
			" -P -O -K >>", FILEP);
		wrt_tmp3(I2, I2, Cstep[s], Xzj[f], Yzj[f], Step);
		sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, Dshift[s], \
			" -P -O -K >>", FILEP);
		wrt_tmp3(I2, I2, Cstep[s], Xzj[f], Zzj[f], Step);
		sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, Dshift[s], \
			" -P -O -K >>", FILEP);
	}
	else {
		if (Opt & STEP_BIT){
			wrt_tmp3(I1, I2, Cstep[s], Xzj[f], Yzj[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
			wrt_tmp3(I1, I2, Cstep[s], Xzj[f], Zzj[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
		}
		else if (Opt & NUMBER_BIT){
			wrt_tmp3i(I1, I2, Cnumb[s], Xzj[f], Yzj[f], Ida);
			sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
			wrt_tmp3i(I1, I2, Cnumb[s], Xzj[f], Zzj[f], Ida);
			sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
		}
		else {
			wrt_tmp3(I1, I1, Cstep[s], Xzj[f], Yzj[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
			wrt_tmp3(I1, I1, Cstep[s], Xzj[f], Zzj[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
			wrt_tmp3(I2, I2, Cstep[s], Xzj[f], Yzj[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
			wrt_tmp3(I2, I2, Cstep[s], Xzj[f], Zzj[f], Step);
			sys_call(8, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, Dshift[s], \
				" -P -O -K >>", FILEP);
		}
	}

	/* plot text */

	sprintf(Sdum, Textzj[s], Frame_lbl[f]);
	wrt_tmp();
	sys_call(6, "gmt pstext ", FILET, Maptxt[s], OPTF, " -N -P -O -K >>", FILEP);
	if ( (s == LARGE) && (Opt & LINE_BIT) && (Opt & DRAW_BIT) ){
		if ((Opt & AUTO_BIT) && !(Opt & ANCHOR_BIT) && (Opt & ORIGIN_BIT)){
			sprintf(Sdum,TXZLI,Step[I1],Step[I2],Iu[Frame],Du[Frame],Mad,Theta,Madc);
			wrt_tmp();
		}
		else if ((Opt & AUTO_BIT) && !(Opt & ANCHOR_BIT) && !(Opt & ORIGIN_BIT)){
			sprintf(Sdum,TXZLE,Step[I1],Step[I2],Iu[Frame],Du[Frame],Mad,Theta,Madc);
			wrt_tmp();
		}
		else if ((Opt & AUTO_BIT) && (Opt & ANCHOR_BIT)){
			sprintf(Sdum,TXZLA,Step[I1],Step[I2],Iu[Frame],Du[Frame],Mad,Madc);
			wrt_tmp();
		}
		else if (!(Opt & AUTO_BIT) && !(Opt & ANCHOR_BIT)){
			sprintf(Sdum,TXZLO,Step[I1],Step[I2],Iu[Frame],Du[Frame],Mad,Theta);
			wrt_tmp();
		}
		else if (!(Opt & AUTO_BIT) && (Opt & ANCHOR_BIT)){
			sprintf(Sdum,TXZLOA,Step[I1],Step[I2],Iu[Frame],Du[Frame],Mad);
			wrt_tmp();
		}
		sys_call(6, "gmt pstext ", FILET, Maptxt[2], OPTF, " -N -P -O -K >>", FILEP);
	}
}


/* draw_tickx */

void draw_tickx(s, tick, gap)
int s;
double tick, gap;
{
	double tckln = 2.*gap, antln = 3.*gap;

	sprintf(Sdum, "%.2f %.2f\n%.2f %.2f\n", tick, tckln, tick, -tckln);
	wrt_tmp();
	sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, PEN2S, " -P -O -K >>", FILEP);
	if (tick < 1. && tick > -1.){
		sprintf(Sdum, CTCKXF, tick, -antln, tick);
		wrt_tmp();
	}
	else {
		sprintf(Sdum, CTCKX, tick, -antln, tick);
		wrt_tmp();
	}
	sys_call(7, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, " -P -O -K >>", FILEP);
}


/* draw_ticky */

void draw_ticky(s, tick, gap)
int s;
double tick, gap;
{
	double tckln = 2.*gap, antln = 3.*gap;

	sprintf(Sdum, "%.2f %.2f\n%.2f %.2f\n", tckln, tick, -tckln, tick);
	wrt_tmp();
	sys_call(7, "gmt psxy ", FILET, Mapzj[s], Range, PEN2S, " -P -O -K >>", FILEP);
	if (tick < 1. && tick > -1.){
		sprintf(Sdum, CTCKYF, -antln, tick, tick);
		wrt_tmp();
	}
	else {
		sprintf(Sdum, CTCKY, -antln, tick, tick);
		wrt_tmp();
	}
	sys_call(7, "gmt pstext ", FILET, Mapzj[s], Range, OPTF, " -P -O -K >>", FILEP);
}
#undef TICKZJ
#undef CONT
#undef CLBL
#undef CTCKX
#undef CTCKXF
#undef CTCKY
#undef CTCKYF
#undef TXZLI
#undef TXZLE
#undef TXZLA
#undef TXZLO
#undef TXZLOA
