#include <string.h>
#include "pdirec.h"

#define CNTMAPV	" -JA%.0f/%.0f/11 -R0/360/%.0f/%.0f"
#define TICKV	" -Ba90g30/g30"
#define XYV	" -X8.5 -Y2.0"
#define CONT	"%.1f %.1f\n"

extern FILE *Fpt;
extern char Buf[WBUF];
extern unsigned int Opt;
extern int Ns, Nsg, Nst, Nstg, *Rjc, *Rjcg;
extern double *Slt, *Sln, *Vlt, *Vln, *Vltr, *Vlnr, *Vltg, *Vlng, *Vltgr, *Vlngr, \
		Im, Dm, A95, Vltm, Vlnm, Vltmr, Vlnmr;

/* pdrc_vgp -- draw a world map with VGP for the present coordinate frame
	psxy warning to drawing an empty A95 was fixed   120624
*/

void pdrc_vgp(n)
int n;
{
	char mapv[100];
	int i, j;

	/* world map */

	if ( !(Opt & S_HEMI_BIT) )
		sprintf(mapv, CNTMAPV, Sln[n], 90., 0., 90.);
	else
		sprintf(mapv, CNTMAPV, Sln[n], -90., -90., 0.);
	sys_call(8, "gmt pscoast", mapv, TICKV, GREY, " -Dc -A500/1", XYV, " -P -K >", FILEP);
	sprintf(Buf, CONT, Sln[n], Slt[n]);
	wrt_tmp();
	sys_call(6, "gmt psxy ", FILET, mapv, STAR3O, " -P -O -K >>", FILEP);

	/* plot each VGP */

	for (i = 0; i < Ns; i++){
		if (Rjc[i] == 0){
			sprintf(Buf, CONT, Vln[i], Vlt[i]);   wrt_tmp();
			sys_call(6, "gmt psxy ", FILET, mapv, CIRC2S, " -P -O -K >>", FILEP);
			sprintf(Buf, CONT, Vlnr[i], Vltr[i]);   wrt_tmp();
			sys_call(6, "gmt psxy ", FILET, mapv, CIRC2O, " -P -O -K >>", FILEP);
		}
		else {
			sprintf(Buf, CONT, Vln[i], Vlt[i]);   wrt_tmp();
			sys_call(6, "gmt psxy ", FILET, mapv, CIRC2SG, " -P -O -K >>", FILEP);
			sprintf(Buf, CONT, Vlnr[i], Vltr[i]);   wrt_tmp();
			sys_call(6, "gmt psxy ", FILET, mapv, CIRC2OG, " -P -O -K >>", FILEP);
		}
	}

	/* plot each VGP corresponding to GTC data (NOT for the rejected ones) */

	if ((Ns==0 && Nsg==1) || (Ns==0 && Nsg==2))
		;
	else {
		for (j = 0; j < Nsg; j++){
			if (Rjcg[j] == 1) continue;
			sprintf(Buf, CONT, Vlng[j], Vltg[j]);   wrt_tmp();
			sys_call(6, "gmt psxy ", FILET, mapv, CIRC2S, " -P -O -K >>", FILEP);
			sprintf(Buf, CONT, Vlngr[j], Vltgr[j]);   wrt_tmp();
			sys_call(6, "gmt psxy ", FILET, mapv, CIRC2O, " -P -O -K >>", FILEP);
		}
	}

	/* plot a mean VGP & a circle of A95 */

	if ( (Nst>=1) || (Nst==0 && Nstg>=2) ){
		sprintf(Buf, CONT, Vlnm, Vltm);   wrt_tmp();
		sys_call(6, "gmt psxy ", FILET, mapv, CIRC3S, " -P -O -K >>", FILEP);
		sprintf(Buf, CONT, Vlnmr, Vltmr);   wrt_tmp();
		sys_call(6, "gmt psxy ", FILET, mapv, CIRC3O, " -P -O -K >>", FILEP);
	}
	if (A95 > 0.){
		pdrc_a95v(Slt[n], Sln[n], Im, Dm, A95, 64, 0);
		sys_call(6, "gmt psxy ", FILET, mapv, PEN3S, " -P -O -K >>", FILEP);
		pdrc_a95v(Slt[n], Sln[n], Im, Dm, A95, 64, 1);
		sys_call(6, "gmt psxy ", FILET, mapv, PEN3D, " -P -O -K >>", FILEP);
	}
}

/* pdrc_a95v */

int pdrc_a95v(slat, slon, inc, dec, a95, na, flip)
int na, flip;
double slat, slon, inc, dec, a95;
{
	int i;
	double inca[NAMAX+1], deca[NAMAX+1], vlat, vlon;

	if ((Fpt = fopen(FILET, "w")) == NULL) error("pdrc_a95v: error of open a TMP file!");
	if (alph95(inc, dec, a95, na, inca, deca) == -1) return(-1);
	if (flip == 0){
		for (i = 0; i <= na; i++){
			fldvgp(slat, slon, inca[i], deca[i], &vlat, &vlon);
			fprintf(Fpt, CONT, vlon, vlat);
		}
	}
	else if (flip == 1){
		for (i = 0; i <= na; i++){
			fldvgp(slat, slon, inca[i], deca[i], &vlat, &vlon);
			vlon += 180.;   checklon(&vlon, 0);
			fprintf(Fpt, CONT, vlon, -vlat);
		}
	}
	fclose(Fpt);
	return(1);
}
#undef CNTMAPV
#undef TICKV
#undef XYV
#undef CONT
