/* pi_help.h -- defines some messages use in pinte
	M for norMalize TRM axis   072514
	C for circle & Z for zj or chi-T   092613
*/

#define ERRFILE "Error in fopen!"
#define COMMAND "+,-,0,9,L,C,S,N,I,A,O,T,Z,P,H,Q?"
#define USAGE   "Usage: pinte [-H] file"

#define HELP1   "HELP MESSAGE OF PINTE\n\
  Analysis of Thellier paleointensity results V3.2.3, H. Tanaka, 2019\n\
  Line & circle fitting to Arai plot with GMT 5.4.3 of Wessel & others 2018\n\
  Compatibility with GMT 6.3.0 classic mode is ascertained, 2024\n\
Usage:\n\
  pinte [-H] file \n\n\
Options:\n\
  H -- show this Help message\n\n\
Commands during analysis:\n\
  \'+\'-next, \'-\'-back, \'0\'-first, \'9\'-last, \'L\'ine-fit, \'C\'ircle-fit,\n\
  \'S\'cale-trm, \'N\'ormalize-trm, zj-or\'I\'entation, zj-\'A\'nchor-on/off,\n\
  ann\'O\'t-temp/num, p\'T\'rm_line-on/off, \'Z\'j-trm/chi, \'P\'sfile, \'H\'elp, \'Q\'uit\n\n\
Input file:\n\
  Experimental protocol should be common throughout the included sample data,\n\
  which shoud be assigned at the beginning of the file by either ZI, IZZI, IZ.\n\
  Line with first letter of \"#\" or \"%\" is a comment line.\n\
  More than one pTRM tests can be put for second step or later.\n\
  Only one MD pTRM tail check is allowed for every step.\n\
  Remanence directions are shown in either core or in situ frame,\n\
  if core orientation is included (when omitted zero is assigned).\n\n\
  Format of ZI protocol (Coe et al., 1978):\n\
   [$$ ZI (Coe)]           -- ZI or Coe at the beginning can be omitted\n\
    $ sample [azim plun]   -- every sample data begins with \'$\'\n\
      20 mag inc dec [chi] -- first line should be room temp data\n\
     100 mag inc dec [chi] -- Zero step\n\
    +100 mag inc dec [chi] -- Inducing step\n\
     150 mag inc dec [chi] -- Zero step\n\
   [+100 mag inc dec [chi] -- pTRM test]\n\
    +150 mag inc dec [chi] -- Inducing step\n\
   [ 150 mag inc dec [chi] -- MD pTRM tail check]\n\
     200 mag inc dec [chi]\n\
        ...\n\n\
  Format of IZZI protocol (Tauxe & Staudigel, 2004):\n\
    $$ IZZI (Tauxe)        -- IZZI at the beginning with the leading \"$$\"\n\
    $ sample [azim plun]   -- every sample data begins with \'$\'\n\
      20 mag inc dec [chi] -- first line should be room temp data\n\
    +100 mag inc dec [chi] -- Inducing step\n\
     100 mag inc dec [chi] -- Zero step\n\
     150 mag inc dec [chi] -- Zero step\n\
   [+100 mag inc dec [chi] -- pTRM test]\n\
    +150 mag inc dec [chi] -- Inducing step\n\
   [ 150 mag inc dec [chi] -- MD pTRM tail check]\n\
    +200 mag inc dec [chi]\n\
        ...\n\n\
  Format of IZ protocol (Aitken et al., 1988):\n\
    $$ IZ (Aitken)         -- IZ at the beginnig with the leading \"$$\"\n\
    $ sample [azim plun]   -- every sample data begins with \'$\'\n\
      20 mag inc dec [chi] -- first line should be room temp data\n\
    +100 mag inc dec [chi] -- Inducing step\n\
     100 mag inc dec [chi] -- Zero step\n\
    +150 mag inc dec [chi] -- Inducing step\n\
   [ 100 mag inc dec [chi] -- pTRM test]\n\
     150 mag inc dec [chi] -- Zero step\n\
    +200 mag inc dec [chi]\n\
        ...\n\n\
Output files:\n\
  1. Results of line & circle fitting are automatically written to\n\
    \"sample.PI\" every time calculation is made with OVERWRITE mode.\n\
  2. P command creates a PS file with user specified name.\n\
  3. \"PINTE.PS\" is re-written every time regression analysis is carried out.\n\
(Q to quit)"

#define HELP2   \
"Commands:\n\
  \e[1m+\e[m-next, \e[1m-\e[m-back, \e[1m0\e[m-first, \e[1m9\e[m-last, \e[1mL\e[mine-fit, \e[1mC\e[mircle-fit,\n\
  \e[1mS\e[mcale-trm, \e[1mN\e[mormalize-trm, zj-or\e[1mI\e[mentation, zj-\e[1mA\e[mnchor-on/off,\n\
  ann\e[1mO\e[mt-temp/num, p\e[1mT\e[mrm_line-on/off, \e[1mZ\e[mj-trm/chi, \e[1mP\e[msfile, \e[1mH\e[melp, \e[1mQ\e[muit"
