#include "pinte.h"

extern unsigned int Opt;
extern FILE *Fpt;
extern char Buf[WBUF];

/* pi_plot -- initialize GMT and plot diagrams of nth sample based on the setup by pi_gmtdat(), 
	and defines functions used to write a GMT temporary data file
 */

void pi_plot(n)
int n;
{
	sys_call(2, "gmt set", GMTPRMS);
	pi_eqn();
	pi_eqt();
	pi_zjn();
	if ((Opt & READ_CHI_BIT) && (Opt & PLOT_CHI_BIT))
		pi_chi();
	else
		pi_zjt();
	pi_arai(n);
}

/* wrt_tmp -- write an external Buf[WBUF] to the GMT TMP file, prepare the buffer by sprintf */

void wrt_tmp()
{
	if ((Fpt = fopen(FILET, "w")) == NULL) error("Error of open a TMP file!");
	if (fprintf(Fpt, "%s", Buf) <= 0)
		error("Error of fprintf at wrt_tmp!");
	fclose(Fpt);
}

/* wrt_tmp2 -- write two double arrays from i1 to i2 for use by psxy */

void wrt_tmp2(i1, i2, cont, d1, d2)
int i1, i2;
char *cont;
double *d1, *d2;
{
	int i;

	if ((Fpt = fopen(FILET, "w")) == NULL) error("Error of open a TMP file!");
	for (i = i1; i <= i2; i++){
		fprintf(Fpt, cont, d1[i], d2[i]);
	}
	fclose(Fpt);
}

/* wrt_tmp3 -- write three double arrays from i1 to i2 for use by pstext */

void wrt_tmp3(i1, i2, cont, d1, d2, d3)
int i1, i2;
char *cont;
double *d1, *d2, *d3;
{
	int i;

	if ((Fpt = fopen(FILET, "w")) == NULL) error("Error of open a TMP file!");
	for (i = i1; i <= i2; i++){
		fprintf(Fpt, cont, d1[i], d2[i], d3[i]);
	}
	fclose(Fpt);
}

/* wrt_tmp3i -- write two double arrays plus one int array for use by pstext */

void wrt_tmp3i(i1, i2, cont, d1, d2, int3)
int i1, i2, *int3;
char *cont;
double *d1, *d2;
{
	int i;

	if ((Fpt = fopen(FILET, "w")) == NULL) error("Error of open a TMP file!");
	for (i = i1; i <= i2; i++){
		fprintf(Fpt, cont, d1[i], d2[i], int3[i]);
	}
	fclose(Fpt);
}
