/* pinte.h -- header file for pinte   072514,092613,0803,0402,0302,1201,1000,0800 */

#include "std.h"
#include "pi_help.h"

FILE *pi_cmd();

#define FILEP	"PINTE.PS"
#define FILET	"PINTE.TMP"

#define WFILE	100	/* maximum length of data file name */
#define WSAMP	12	/* maximum length of sample name */
#define WSTEP	5	/* maximum length of step id */
#define WBUF	1000	/* maximum length of Buf used by wrt_tmp */
#define ZERO	0

/* For use by unsigned int Method */

#define COE	0	/* Coe or ZI */
#define AITKEN	1	/* Aitken or IZ */
#define IZZI	2	/* IZZI or Tauxe */

/* For use by unsigned int Opt */

#define SCALEX_BIT	1
#define PTR_NOLINE_BIT	2
#define TEMP_BIT	4
#define NUMBER_BIT	8
#define REGRES_BIT	16
#define ANCHOR_BIT	32
#define READ_CHI_BIT	64
#define PLOT_CHI_BIT	128
#define IN_SITU_BIT	256
#define CIRCLE_BIT	512
#define NORM_TRM_BIT	1024

/* GMT default parameters */

#define GMTPRMS " PS_MEDIA A4 PROJ_LENGTH_UNIT c MAP_FRAME_TYPE plain MAP_FRAME_PEN 0.5p,black \
MAP_TICK_PEN_PRIMARY 0.5p,black MAP_GRID_PEN_PRIMARY 0.25p,black \
FONT_LABEL 12p,Helvetica-Bold,black FONT_ANNOT_PRIMARY 10p,Helvetica,black MAP_POLAR_CAP none \
FORMAT_TIME_STAMP \"%Y %b %d\""

/* GMT options for equal area plot */

#define MAPE	" -JA180/90/5"
#define TICKE	" -Bg90"
#define RANGEE	" -R0/360/0/90"
#define XYEN	" -X5.0 -Y1.2"
#define XYET	" -X10 -Y2.5"
#define MAPET	" -Jx1c -R-2.5/7.5/-2.5/7.5 -X-2.5 -Y-2.5"
#define TEXTE	"-0.25 5.00 12p,Helvetica-Bold,black LT %s\n\
 5.20  5.00 12p,Helvetica-Bold,black RT %s\n\
 2.50  5.05 10p,Helvetica,black CB 0\n\
 5.05  2.50 10p,Helvetica,black LM 90\n\
 2.50 -0.05 10p,Helvetica,black CT 180\n\
-0.05  2.50 10p,Helvetica,black RM 270\n"

/* GMT options for Zijerveld plot */

#define MAPZ	" -JX6.5/-6.5"
#define TICKZ	" -Bf10"
#define XYZN	" -X-6.50 -Y10.00"
#define XYZT	" -X11.50 -Y2.5"
#define MAPZT	" -Jx1c -R-2.5/7.5/-2.5/7.5 -X-2.5 -Y-2.5"
#define TEXTZ	"0.00 6.55 12p,Helvetica-Bold,black LB %s (%s)\n\
6.50 6.55 12p,Helvetica-Bold,black RB %s\n"

/* GMT options for chi-step plot */

#define MAPC	" -JX6.5/6.5"
#define XYC	" -X11.50 -Y2.5"
#define MAPCT	" -Jx1c -R-2.5/7.5/-2.5/7.5 -X-2.5 -Y-2.5"
#define TEXTC	"0.10 6.75 12p,Helvetica-Bold,black LB @~c@~@-20@- = %s\n"

/* GMT options for Arai plot */

#define XAMAX	1.5
#define YAMAX	1.1
#define MAPA	" -JX15/11"
#define TICKA	" -BWeSn -Bxf0.1a0.5+lTRM -Byf0.1a0.5+lNRM"
#define TICKAC	" -BWeSn -Bxf0.1a0.5+l\"TRM* (NORMALIZED TO UNITY)\" -Byf0.1a0.5+lNRM"
#define XYA	" -X-6.50 -Y11.00"
#define MAPAT	" -Jx1c -R-2.5/15/-2.5/12.5 -X-2.5 -Y-2.5"
#define TEXTA	"0.00 11.50 14p,Helvetica-Bold,black LB %s\n\
15.00 11.50 14p,Helvetica-Bold,black RB %s\n"
#define TEXTAR	"0.00 11.50 14p,Helvetica-Bold,black LB %s  (b = %.3f,  sb = %.3f,  r = %.3f)\n\
15.00 11.50 14p,Helvetica-Bold,black RB %s\n"
#define TEXTARM	"0.00 11.50 14p,Helvetica-Bold,black LB %s  (b* = %.3f,  sb* = %.3f,  r = %.3f)\n\
15.00 11.50 14p,Helvetica-Bold,black RB %s\n"
#define TEXTAC	"0.00 11.50 14p,Helvetica-Bold,black LB %s  (rc = %.2f,  kc = %.3f,  SSE = %.2e)\n\
15.00 11.50 14p,Helvetica-Bold,black RB %s\n"
#define TEXTACM	"0.00 11.50 14p,Helvetica-Bold,black LB %s  (rc* = %.2f,  kc* = %.3f,  SSE* = %.2e)\n\
15.00 11.50 14p,Helvetica-Bold,black RB %s\n"

/* other GMT options */

#define PEN2S	" -W0.25p,black"
#define PEN2D	" -W0.25p,black,2_2:0"
#define PEN2SG	" -W0.25p,132"
#define PEN2DG	" -W0.25p,132,2_2:0"
#define PEN3S	" -W0.5p,black"
#define PEN3D	" -W0.5p,black,2_2:0"
#define PEN3SG	" -W0.5p,132"
#define PEN3DG	" -W0.5p,132,2_2:0"
#define PEN5S	" -W1p,black"
#define PEN5D	" -W1p,black,5_5:0"
#define PEN5SG	" -W1p,132"
#define PEN5DG	" -W1p,132,5_5:0"

#define CIRC5S	" -Sc0.15c -Gblack -W0.50p,black"
#define CIRC5SG	" -Sc0.15c -G132 -W0.50p,132"
#define CIRC5O	" -Sc0.15c -Gwhite -W0.50p,black"
#define CIRC5OG	" -Sc0.15c -Gwhite -W0.50p,132"
#define CIRC8S	" -Sc0.20c -Gblack -W1p,black"
#define CIRC8SG	" -Sc0.20c -G132 -W1p,132"
#define TRIA3S	" -St0.10c -Gblack -W0.25p,black"
#define TRIA3SG	" -St0.10c -G132 -W0.25p,132"
#define TRIA3O	" -St0.10c -Gwhite -W0.25p,black"
#define TRIA3OG	" -St0.10c -Gwhite -W0.25p,132"
#define TRIA5S	" -St0.15c -Gblack -W0.50p,black"
#define TRIA5SG	" -St0.15c -G132 -W0.50p,132"
#define TRIA5O	" -St0.15c -Gwhite -W0.50p,black"
#define TRIA5OG	" -St0.15c -Gwhite -W0.50p,132"
#define TRIA8SG	" -St0.20c -G132 -W1p,132"
#define CROSS3	" -Sx0.10c -Gblack -W0.25p,black"
#define CROSS3G	" -Sx0.10c -G132 -W0.25p,132"
#define CROSS5	" -Sx0.15c -Gblack -W0.50p,black"
#define CROSS5G	" -Sx0.15c -G132 -W0.50p,132"
#define CROSS8	" -Sx0.20c -Gblack -W0.50p,black"
#define CROSS8G	" -Sx0.20c -G132 -W0.50p,132"
#define SQUAR8G " -Ss0.20c -G132 -W1p,132"
#define DSHIFT4	" -D0.10/0.10"
#define OPTF	" -F+f+j"

/* Type of functions */

void quit_gv();
void pi_arai(), draw_ptrlin(), wrt_circle();
void pi_chi();
FILE *pi_cmd();
int pi_comd(), do_regres(), do_circle(), go_next(), go_back(), change_scale();
	void normalize_trm(), change_anchor(), out_psfile(), go_first(), go_last(), do_init(), \
	change_orient(), disable_annot(), change_ptlin(), zjt_or_chi();
int pi_dat(); void count_step(), pi_mem1(), pi_mem2(), pi_mem3(), free_all();
void pi_eqn(), pi_eqt();
void pi_gmtdat(), set_eqdata(), set_chidat(), set_insitu_id(), set_insitu_xyz();
	double set_zjdata(), set_dX(), set_scalax();
int pi_ntp(), pi_ntpC(), pi_ntpA(), pi_ntpIZZI(), seek_stept(); void cal_trmC(), cal_ptrmC(), \
	cal_trmA(), cal_ptrmA(), cal_mdtl();
void pi_plot(), wrt_tmp(), wrt_tmp2(), wrt_tmp3(), wrt_tmp3i();
void pi_regres(), cal_circle(), cal_frac(), cal_zstar(), set_zjrgline(), wrt_result();
void pi_zjn(), pi_zjt(), draw_tickx(), draw_ticky();
