#include <string.h>
#include "pstat.h"

#define MAPF	" -JA180/90/11.0"
#define TICKF	" -Bg90"
#define RANGEF	" -R0/360/0/90"
#define XYF	" -Y13.5"
#define CONT	"%.1f %.1f\n"
#define MAPTXT	" -Jx1 -R0/12.0/0/12.0"
#define TEXTEQ	" 5.5  11.1 14p,Helvetica,black CB 0\n\
11.1   5.5 14p,Helvetica,black LM 90\n\
 5.5  -0.1 14p,Helvetica,black CT 180\n\
-0.1   5.5 14p,Helvetica,black RM 270\n"

extern FILE *Fpt;
extern char Buf[WBUF], *Frame_lbl[];
extern unsigned int Opt;
extern int Nsite, Nstat, *Id, *Rjc, Nnm, Nsm;
extern double *Is, *Ds, *Dq, *A95, Inm, Dnm, Ism, Dsm, A95nm, A95sm;

/* pst_fld -- plot in situ (or tilted) paleodirections for n'th site */

void pst_fld(n)
int n;
{
	int i;

	/* base map */

	sys_call(7, "gmt psbasemap", MAPF, TICKF, RANGEF, XYF, " -P -O -K >>", FILEP);

	/* first draw a95 for each site mean directions */

	if (Opt & ALPH_FLD){
		for (i = 0; i < Nsite; i++){
			if (Rjc[i] == 0){
				pst_a95f(Is[Id[i]], Ds[Id[i]], A95[Id[i]], 32, 0);
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2S, \
					" -P -O -K >>", FILEP);
				pst_a95f(Is[Id[i]], Ds[Id[i]], A95[Id[i]], 32, 1);
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2D, \
					" -P -O -K >>", FILEP);
			}
			else {
				pst_a95f(Is[Id[i]], Ds[Id[i]], A95[Id[i]], 32, 0);
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2SG, \
					" -P -O -K >>", FILEP);
				pst_a95f(Is[Id[i]], Ds[Id[i]], A95[Id[i]], 32, 1);
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2DG, \
					" -P -O -K >>", FILEP);
			}
		}
	}

	/* plot each site mean dirctions */

	for (i = 0; i < Nsite; i++){
		if (Rjc[i] == 0){
			sprintf(Buf, CONT, Dq[i], Is[Id[i]]);   wrt_tmp();
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC2S, " -P -O -K >>", FILEP);
			sprintf(Buf, CONT, Dq[i], -Is[Id[i]]);   wrt_tmp();
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC2O, " -P -O -K >>", FILEP);
		}
		else {
			sprintf(Buf, CONT, Dq[i], Is[Id[i]]);   wrt_tmp();
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC2SG, " -P -O -K >>", FILEP);
			sprintf(Buf, CONT, Dq[i], -Is[Id[i]]);   wrt_tmp();
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC2OG, " -P -O -K >>", FILEP);
		}
	}

	/* plot the mean directions with circle of A95 for normal and reversed separately */

	if (Opt & MEAN_FLD){
		if (Nnm > 0){
			sprintf(Buf, CONT, 360. - Dnm, Inm);   wrt_tmp();
/*			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC3S, " -P -O -K >>", FILEP); */
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC3SR, " -P -O -K >>", FILEP);
			sprintf(Buf, CONT, 360. - Dnm, -Inm);   wrt_tmp();
/*			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC3O, " -P -O -K >>", FILEP); */
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC3OR, " -P -O -K >>", FILEP);
			pst_a95f(Inm, Dnm, A95nm, 64, 0);
/*			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3S, " -P -O -K >>", FILEP); */
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3SR, " -P -O -K >>", FILEP);
			pst_a95f(Inm, Dnm, A95nm, 64, 1);
/*			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3D, " -P -O -K >>", FILEP); */
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3DR, " -P -O -K >>", FILEP);
		}
		if (Nsm > 0){
			sprintf(Buf, CONT, 360. - Dsm, Ism);   wrt_tmp();
/*			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC3S, " -P -O -K >>", FILEP); */
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC3SR, " -P -O -K >>", FILEP);
			sprintf(Buf, CONT, 360. - Dsm, -Ism);   wrt_tmp();
/*			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC3O, " -P -O -K >>", FILEP); */
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC3OR, " -P -O -K >>", FILEP);
			pst_a95f(Ism, Dsm, A95sm, 64, 0);
/*			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3S, " -P -O -K >>", FILEP); */
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3SR, " -P -O -K >>", FILEP);
			pst_a95f(Ism, Dsm, A95sm, 64, 1);
/*			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3D, " -P -O -K >>", FILEP); */
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3DR, " -P -O -K >>", FILEP);
		}
	}

	/* plot labels */

	sprintf(Buf, TEXTEQ);   wrt_tmp();
	sys_call(6, "gmt pstext ", FILET, MAPTXT, OPTF, " -N -P -O -K >>", FILEP);
}

/* pst_a95f */

int pst_a95f(inc, dec, a95, na, flip)
int na, flip;
double inc, dec, a95;
{
	int i;
	double inca[NAMAX+1], deca[NAMAX+1];

	if ((Fpt = fopen(FILET, "w")) == NULL) error("pst_a95f: error of open a TMP file!");
	if (alph95(inc, dec, a95, na, inca, deca) == -1) return(-1);
	if (flip == 0)
		for (i = 0; i <= na; i++)
			fprintf(Fpt, CONT, 360. - deca[i], inca[i]);
	else if (flip == 1)
		for (i = 0; i <= na; i++)
			fprintf(Fpt, CONT, 360. - deca[i], -inca[i]);
	fclose(Fpt);
	return(1);
}
#undef MAPF
#undef TICKF
#undef RANGEF
#undef XYF
#undef CONT
#undef MAPTXT
#undef TEXTEQ
