#include "pstat.h"

#define GMTPRMS " PS_MEDIA A4 PROJ_LENGTH_UNIT c MAP_FRAME_TYPE plain MAP_FRAME_PEN 1p,black \
MAP_TICK_PEN_PRIMARY 0.5p,black MAP_GRID_PEN_PRIMARY 0.25p,black FONT_LABEL 12p,Helvetica,black \
FONT_ANNOT_PRIMARY 10p,Helvetica,black MAP_POLAR_CAP none FORMAT_TIME_STAMP \"%Y %b %d\""

extern unsigned int Opt;
extern FILE *Fpt;
extern char Buf[WBUF];

/* pst_plot -- highest program with utitilities to write data into the GMT TMP file */

void pst_plot(n)
int n;
{
	sys_call(2, "gmt set", GMTPRMS);
	pst_vgp(n);
	if ( !(Opt & AXIAL_DPF) )
		pst_fld(n);
	else
		pst_fld_dp(n);
	pst_text(n);
	pst_results(n);
}

/* wrt_tmp -- write an external Buf[WBUF] to the GMT TMP file, prepare the buffer by sprintf */

void wrt_tmp()
{
	if ((Fpt = fopen(FILET, "w")) == NULL) error("Error of open a TMP file!");
	if (fprintf(Fpt, "%s", Buf) <= 0)
		error("Error of fprintf at wrt_tmp!");
	fclose(Fpt);
}

/* wrt_tmp2 -- write two double arrays from i1 to i2 for use by psxy */

void wrt_tmp2(i1, i2, cont, d1, d2)
int i1, i2;
char *cont;
double *d1, *d2;
{
	int i;

	if ((Fpt = fopen(FILET, "w")) == NULL) error("Error of open a TMP file!");
	for (i = i1; i <= i2; i++){
		fprintf(Fpt, cont, d1[i], d2[i]);
	}
	fclose(Fpt);
}

/* wrt_tmp3 -- write three double arrays from i1 to i2 for use by pstext */

void wrt_tmp3(i1, i2, cont, d1, d2, d3)
int i1, i2;
char *cont;
double *d1, *d2, *d3;
{
	int i;

	if ((Fpt = fopen(FILET, "w")) == NULL) error("Error of open a TMP file!");
	for (i = i1; i <= i2; i++){
		fprintf(Fpt, cont, d1[i], d2[i], d3[i]);
	}
	fclose(Fpt);
}

/* wrt_tmp3i -- write two double arrays plus one int array for use by pstext */

void wrt_tmp3i(i1, i2, cont, d1, d2, int3)
int i1, i2, *int3;
char *cont;
double *d1, *d2;
{
	int i;

	if ((Fpt = fopen(FILET, "w")) == NULL) error("Error of open a TMP file!");
	for (i = i1; i <= i2; i++){
		fprintf(Fpt, cont, d1[i], d2[i], int3[i]);
	}
	fclose(Fpt);
}
#undef GMTPRMS
