#include <string.h>
#include "pstat.h"

#define CNT0	"Paleomagnetic Statistics by PSTAT\n\nGroup: %s (File: %s)\n\n\
  N0  Slat   Slon   NPlat  NPlon  Center_ASD\n\
 %3d %6.2f %6.2f %6.2f %6.2f  %s\n\n"
#define CNTV	"VGP:\n\
         N  Plat   Plon    A95    R        k      S      St     Sw     Nw\n\
 Total %3d %6.2f %6.2f %6.2f %7.4f %7.2f %6.2f %6.2f %6.2f %6.2f\n\
 Norml %3d %6.2f %6.2f %6.2f %7.4f %7.2f %6.2f %6.2f %6.2f %6.2f\n\
 Rvers %3d %6.2f %6.2f %6.2f %7.4f %7.2f %6.2f %6.2f %6.2f %6.2f\n"
#define CNTF	"%s:\n\
        Incm   Decm    a95    R        k      S      St     Sw\n\
 Total %6.2f %6.2f %6.2f %7.4f %7.2f %6.2f %6.2f %6.2f\n\
 Norml %6.2f %6.2f %6.2f %7.4f %7.2f %6.2f %6.2f %6.2f\n\
 Rvers %6.2f %6.2f %6.2f %7.4f %7.2f %6.2f %6.2f %6.2f\n"
#define CNTD0	"\nsite        vlat  vlon  dltv rj  I     D    a95   dlt   \
N   Sw   Swv    Ip   Dp    dltp  slat  slon\n"
#define CNTD	"%-10s %5.1f %5.1f %5.1f %1s %5.1f %5.1f %5.1f %5.1f \
%2.0f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f\n"

extern char Filed[WFILE], **Group, **Site;
extern unsigned int Opt;
extern int Nsite, Nm, Nnm, Nsm, *Id, *Rjc;
extern double Im, Dm, Inm, Dnm, Ism, Dsm, Ipm, Dpm, Ipnm, Dpnm, Ipsm, Dpsm, Vtm, Vnm, Vnmr, \
		Vtnm, Vnnm, Vnnmr, Vtsm, Vnsm, Vnsmr, A95m, A95nm, A95sm, A95pm, A95pnm, \
		A95psm, A95vm, A95vnm, A95vsm, Rm, Rnm, Rsm, Rpm, Rpnm, Rpsm, Rvm, Rvnm, \
		Rvsm, Km, Knm, Ksm, Kpm, Kpnm, Kpsm, Kvm, Kvnm, Kvsm, Sltm, Slnm, Nplt, Npln;
extern double Nwm, Nwnm, Nwsm, Swm, Swnm, Swsm, Swvm, Swvnm, Swvsm, Sb, Sbn, Sbs, Sbp, \
		Sbpn, Sbps, Sbv, Sbvn, Sbvs, St, Stn, Sts, Stp, Stpn, Stps, Stv, Stvn, Stvs;
extern double *Slt, *Sln, *Is, *Ds, *Ip, *Dp, *A95, *Nsmpl, *Vlt, *Vln, *Sw, *Swv, \
		*Dlt, *Dltp, *Dltv;

/* pst_results -- write detailed results of the Fisher statistics to "group_name.PST" */

void pst_results(n)
int n;
{
	FILE *fp;
	char filer[WFILE], *srjct[] = {" ", "*"}, sdum[15];
	int i;

	strcpy(filer, Group[n]);   strcat(filer, ".PST");
	if ((fp = fopen(filer, "w")) == NULL) error("pst_results: error of fopen!");
	if ( !(Opt & ASD_NPOLE) ) strcpy(sdum, "MEAN");
	else strcpy(sdum, "NORTH POLE");
	fprintf(fp, CNT0, Group[n], Filed, Nsite, Sltm, Slnm, Nplt, Npln, sdum);

	fprintf(fp, CNTV, Nm, Vtm, Vnm, A95vm, Rvm, Kvm, Sbv, Stv, Swvm, Nwm, \
		Nnm, Vtnm, Vnnm, A95vnm, Rvnm, Kvnm, Sbvn, Stvn, Swvnm, Nwnm,\
		Nsm, Vtsm, Vnsm, A95vsm, Rvsm, Kvsm, Sbvs, Stvs, Swvsm, Nwsm);
	fprintf(fp, CNTF, "Field", Im, Dm, A95m, Rm, Km, Sb, St, Swm, \
		Inm, Dnm, A95nm, Rnm, Knm, Sbn, Stn, Swnm, \
		Ism, Dsm, A95sm, Rsm, Ksm, Sbs, Sts, Swsm);
	fprintf(fp, CNTF, "ADP Field", Ipm, Dpm, A95pm, Rpm, Kpm, Sbp, Stp, Swm, \
		Ipnm, Dpnm, A95pnm, Rpnm, Kpnm, Sbpn, Stpn, Swnm, \
		Ipsm, Dpsm, A95psm, Rpsm, Kpsm, Sbps, Stps, Swsm);
	fprintf(fp, CNTD0);
	for (i = 0; i < Nsite; i++)
		fprintf(fp, CNTD, Site[Id[i]], Vlt[Id[i]], Vln[Id[i]], Dltv[i], srjct[Rjc[i]], \
			Is[Id[i]], Ds[Id[i]], A95[Id[i]], Dlt[i], Nsmpl[Id[i]], Sw[Id[i]], \
			Swv[Id[i]], Ip[i], Dp[i], Dltp[i], Slt[Id[i]], Sln[Id[i]]);
	fclose(fp);
}
#undef CNT0
#undef CNTV
#undef CNTF
#undef CNTD0
#undef CNTD
