#include <math.h>
#include "pstat.h"

extern unsigned int Opt;
extern int Nsite, Nstat, *Id, *Rjc, Nm, Nnm, Nsm;
extern double *Slt, *Sln, *Is, *Ds, *Ip, *Dp, *A95, *Nsmpl, *R, *K, *Vlt, *Vln, \
		*Sw, *Swv, *Dlt, *Dltp, *Dltv, *Dlt2, *Dltp2, *Dltv2;
extern double Im, Dm, Inm, Dnm, Ism, Dsm, Ipm, Dpm, Ipnm, Dpnm, Ipsm, Dpsm, Vtm, Vnm, Vnmr, \
		Vtnm, Vnnm, Vnnmr, Vtsm, Vnsm, Vnsmr, A95m, A95nm, A95sm, A95pm, A95pnm, A95psm, \
		A95vm, A95vnm, A95vsm, Rm, Rnm, Rsm, Rpm, Rpnm, Rpsm, Rvm, Rvnm, Rvsm, \
		Km, Knm, Ksm, Kpm, Kpnm, Kpsm, Kvm, Kvnm, Kvsm, Nplt, Npln;
extern double Nwm, Nwnm, Nwsm, Swm, Swnm, Swsm, Swvm, Swvnm, Swvsm, Sb, Sbn, Sbs, Sbp, \
		Sbpn, Sbps, Sbv, Sbvn, Sbvs, St, Stn, Sts, Stp, Stpn, Stps, Stv, Stvn, Stvs;

static int k, kn, ks;
static double x, y, z, xn, y_n, zn, xs, ys, zs, xp, yp, zp, xpn, ypn, zpn, \
		xps, yps, zps, xv, yv, zv, xvn, yvn, zvn, xvs, yvs, zvs;

/* pst_statf -- Fisher statisitcs of site mean directions & VGPs */

void pst_statf(n)
int n;
{
	int i;
	double d;

	if (Nsite <= 1){
		set_one_site();   return;
	}
	summ_data();
	if ((Nstat = k) == 1) error("pst_statf: error of Nstat=1!");
	statf_result(k, x, y, z, &Im, &Dm, &Nm, &A95m, &Rm, &Km);
	statf_result(k, xp, yp, zp, &Ipm, &Dpm, &d, &A95pm, &Rpm, &Kpm);
	statf_result(k, xv, yv, zv, &Vtm, &Vnm, &d, &A95vm, &Rvm, &Kvm);
	statf_result(kn, xn, y_n, zn, &Inm, &Dnm, &Nnm, &A95nm, &Rnm, &Knm);
	statf_result(kn, xpn, ypn, zpn, &Ipnm, &Dpnm, &d, &A95pnm, &Rpnm, &Kpnm);
	statf_result(kn, xvn, yvn, zvn, &Vtnm, &Vnnm, &d, &A95vnm, &Rvnm, &Kvnm);
	statf_result(ks, xs, ys, zs, &Ism, &Dsm, &Nsm, &A95sm, &Rsm, &Ksm);
	statf_result(ks, xps, yps, zps, &Ipsm, &Dpsm, &d, &A95psm, &Rpsm, &Kpsm);
	statf_result(ks, xvs, yvs, zvs, &Vtsm, &Vnsm, &d, &A95vsm, &Rvsm, &Kvsm);
	Vnmr = Vnm + 180.;   checklon(&Vnmr, 0);
	Vnnmr = Vnnm + 180.;   checklon(&Vnnmr, 0);
	Vnsmr = Vnsm + 180.;   checklon(&Vnsmr, 0);
	Nwm /= Nm;   Swm /= Nm;   Swvm /= Nm;
	if (Nnm == 0){
		Nwnm = 0.;   Swnm = 0.;   Swvnm = 0.;
	}
	else {
		Nwnm /= Nnm;   Swnm /= Nnm;   Swvnm /= Nnm;
	}
	if (Nsm == 0){
		Nwsm = 0.;   Swsm = 0.;   Swvsm = 0.;
	}
	else {
		Nwsm /= Nsm;   Swsm /= Nsm;   Swvsm /= Nsm;
	}
	cal_delta();
	cal_asd();
	St /= (Nm-1);   Sb = ((d=St-Swm/Nwm) > 0.) ? sqrt(d) : -1.;   St = sqrt(St);
	Stp /= (Nm-1);   Sbp = ((d=Stp-Swm/Nwm) > 0.) ? sqrt(d) : -1.;   Stp = sqrt(Stp);
	Stv /= (Nm-1);   Sbv = ((d=Stv-Swvm/Nwm) > 0.) ? sqrt(d) : -1.;   Stv = sqrt(Stv);
	if (Nnm == 0){
		Stn = Stpn = Stvn = Sbn = Sbpn = Sbvn = -1.;
	}
	else if (Nnm == 1){
/*		Sbn = Stn = sqrt(Stn);  Sbpn = Stpn = sqrt(Stpn);  Sbvn = Stvn = sqrt(Stvn); */
		Sbn = Stn = Sbpn = Stpn = Sbvn = Stvn = 0.;
	}
	else {
		Stn/=(Nnm-1);  Sbn=((d=Stn-Swnm/Nwnm)>0.) ? sqrt(d) : -1.;  Stn=sqrt(Stn);
		Stpn/=(Nnm-1);  Sbpn=((d=Stpn-Swnm/Nwnm)>0.) ? sqrt(d) : -1.;  Stpn=sqrt(Stpn);
		Stvn/=(Nnm-1);  Sbvn=((d=Stvn-Swvnm/Nwnm)>0.) ? sqrt(d) : -1.;  Stvn=sqrt(Stvn);
	}
	if (Nsm == 0){
		Sts = Stps = Stvs = Sbs = Sbps = Sbvs = -1.;
	}
	else if (Nsm == 1){
/*		Sbs = Sts = sqrt(Sts);  Sbps = Stps = sqrt(Stps);  Sbvs = Stvs = sqrt(Stvs); */
		Sbs = Sts = Sbps = Stps = Sbvs = Stvs = 0.;
	}
	else {
		Sts/=(Nsm-1);  Sbs=((d=Sts-Swsm/Nwsm)>0.) ? sqrt(d) : -1.;  Sts=sqrt(Sts);
		Stps/=(Nsm-1);  Sbps=((d=Stps-Swsm/Nwsm)>0.) ? sqrt(d) : -1.;  Stps=sqrt(Stps);
		Stvs/=(Nsm-1);  Sbvs=((d=Stvs-Swvsm/Nwsm)>0.) ? sqrt(d) : -1.;  Stvs=sqrt(Stvs);
	}
	Swm = sqrt(Swm);   Swvm = sqrt(Swvm);
	Swnm = sqrt(Swnm);   Swvnm = sqrt(Swvnm);
	Swsm = sqrt(Swsm);   Swvsm = sqrt(Swvsm);
}

/* set_one_site, set_one_normal, and set_one_reverse */

void set_one_site()
{
	Im = Is[Id[0]];   Dm = Ds[Id[0]];   Ipm = Ip[0];   Dpm = Dp[0];
	Nm = 1;   A95m = -1.;   Rm = 1.;   Km = -1.;
	A95pm = -1.;   Rpm = 1.;   Kpm = -1.;
	Vtm = Vlt[Id[0]];   Vnm = Vln[Id[0]];
	Vnmr = Vnm + 180.;   checklon(&Vnmr, 0);
	A95vm = -1.;   Rvm = 1.;   Kvm = -1.;
	Dlt[0] = Dltp[0] = Dltv[0] = 0.;
	Swm = Sw[Id[0]];   Swvm = Swv[Id[0]];
	St = Stp = Stv = Stn = Stpn = Stvn = Sts = Stps = Stvs = -1.;
	Sb = Sbp = Sbv = Sbn = Sbpn = Sbvn = Sbs = Sbps = Sbvs = -1.;
	if (vecumuls(Vtm, Vnm, Nplt, Npln) >= 0.) set_one_normal();
	else set_one_reverse();
}

void set_one_normal()
{
	Inm = Im;   Dnm = Dm;   Ipnm = Ipm;   Dpnm = Dpm;
	Nnm = 1;   A95nm = -1.;   Rnm = 1.;   Knm = -1.;
	A95pnm = -1.;   Rpnm = 1.;   Kpnm = -1.;
	Vtnm = Vtm;   Vnnm = Vnm;   Vnnmr = Vnmr;
	A95vnm = -1.;   Rvnm = 1.;   Kvnm = -1.;
	Ism = Dsm = Ipsm = Dpsm = 0.;
	Nsm = 0;   A95sm = Rsm = Ksm = -1.;
	A95psm = Rpsm = Kpsm = -1.;
	Vtsm = Vnsm = Vnsmr = 0.;
	A95vsm = Rvsm = Kvsm = -1.;
}

void set_one_reverse()
{
	Inm = Dnm = Ipnm = Dpnm = 0.;
	Nnm = 0;   A95nm = Rnm = Knm = -1.;
	A95pnm = Rpnm = Kpnm = -1.;
	Vtnm = Vnnm = Vnnmr = 0.;
	A95vnm = Rvnm = Kvnm = -1.;
	Ism = Im;   Dsm = Dm;   Ipsm = Ipm;   Dpsm = Dpm;
	Nsm = 1;   A95sm = -1.;   Rsm = 1.;   Ksm = -1.;
	A95psm = -1.;   Rpsm = 1.;   Kpsm = -1.;
	Vtsm = Vtm;   Vnsm = Vnm;   Vnsmr = Vnmr;
	A95vsm = -1.;   Rvsm = 1.;   Kvsm = -1.;
}

/* summ_data, summ_normal, and summ_reverse */

void summ_data()
{
	int i;
	double a, b, c, ap, bp, cp, av, bv, cv;

	k = kn = ks = 0;
	x = y = z = xn = y_n = zn = xs = ys = zs = 0.;
	xp = yp = zp = xpn = ypn = zpn = xps = yps = zps = 0.;
	xv = yv = zv = xvn = yvn = zvn = xvs = yvs = zvs = 0.;
	Nwm = Nwnm = Nwsm = 0.;
	Swm = Swnm = Swsm = Swvm = Swvnm = Swvsm = 0.;
	for (i = 0; i < Nsite; i++){
		if (Rjc[i] == 1) continue;
		magcar(1., Is[Id[i]], Ds[Id[i]], &a, &b, &c);
		magcar(1., Ip[i], Dp[i], &ap, &bp, &cp);
		magcar(1., Vlt[Id[i]], Vln[Id[i]], &av, &bv, &cv);
		Nwm += Nsmpl[Id[i]];
		Swm += Sw[Id[i]]*Sw[Id[i]];   Swvm += Swv[Id[i]]*Swv[Id[i]];
		if (vecumuls(Vlt[Id[i]], Vln[Id[i]], Nplt, Npln) >= 0.)
			summ_normal(i, a, b, c, ap, bp, cp, av, bv, cv);
		else
			summ_reverse(i, a, b, c, ap, bp, cp, av, bv, cv);
 	}
}

void summ_normal(i, a, b, c, ap, bp, cp, av, bv, cv)
int i;
double a, b, c, ap, bp, cp, av, bv, cv;
{
	x += a;   y += b;   z += c;
	xp += ap;   yp += bp;   zp += cp;
	xv += av;   yv += bv;   zv += cv;
	k++;
	xn += a;   y_n += b;   zn += c;
	xpn += ap;   ypn += bp;   zpn += cp;
	xvn += av;   yvn += bv;   zvn += cv;
	kn++;
	Nwnm += Nsmpl[Id[i]];
	Swnm += Sw[Id[i]]*Sw[Id[i]];   Swvnm += Swv[Id[i]]*Swv[Id[i]];
}

void summ_reverse(i, a, b, c, ap, bp, cp, av, bv, cv)
int i;
double a, b, c, ap, bp, cp, av, bv, cv;
{
	x -= a;   y -= b;   z -= c;
	xp -= ap;   yp -= bp;   zp -= cp;
	xv -= av;   yv -= bv;   zv -= cv;
	k++;
	xs += a;   ys += b;   zs += c;
	xps += ap;   yps += bp;   zps += cp;
	xvs += av;   yvs += bv;   zvs += cv;
	ks++;
	Nwsm += Nsmpl[Id[i]];
	Swsm += Sw[Id[i]]*Sw[Id[i]];   Swvsm += Swv[Id[i]]*Swv[Id[i]];
}

/* statf_result */

void statf_result(k, x, y, z, inc, dec, n, a95, r, km)
int k, *n;
double x, y, z, *inc, *dec, *a95, *r, *km;
{
	double m, cosa, cosi;

	m = *n = k;
	if (*n == 0){
		*inc = 0.;   *dec = 0.;
		*a95 = -1.;   *r = -1.;   *km = -1.;
		return;
	}
	carmag(x, y, z, r, inc, dec);
	if (*n == 1){
		*a95 = -1.;   *km = -1.;
		return;
	}
	*km = (m - 1.)/(m - (*r));
	cosa = 1.  -  (m - (*r))/(*r)*(pow(20., 1./(m-1.)) - 1.);
	if (cosa > 1.) *a95 = 0.;
	else if (cosa < -1.) *a95 = 180.;
	else *a95 = acos(cosa)*RAD;
}

/* cal_delta, delta_normal, and delta_reverse */

void cal_delta()
{
	int i;

	for (i = 0; i < Nsite; i++){
		if ( !(Opt & ASD_NPOLE) ){
			if (vecumuls(Vlt[Id[i]], Vln[Id[i]], Vtm, Vnm) >= 0.)
				delta_normal(i, 0);
			else
				delta_reverse(i, 0);
		}
		else {
			if (vecumuls(Vlt[Id[i]], Vln[Id[i]], Nplt, Npln) >= 0.)
				delta_normal(i, 1);
			else
				delta_reverse(i, 1);
		}
	}
}

void delta_normal(i, mode)
int i, mode;		/* mode: delta from 0--mean, 1--apparent north pole */
{
	double dumi, dumd;

	switch (mode){
	case 0:
		Dlt[i] = angdif(1., Is[Id[i]], Ds[Id[i]], 1., Im, Dm);
		Dltp[i] = angdif(1., Ip[i], Dp[i], 1., Ipm, Dpm);
		Dltv[i] = angdif(1., Vlt[Id[i]], Vln[Id[i]], 1., Vtm, Vnm);
		Dlt2[i] = angdif(1., Is[Id[i]], Ds[Id[i]], 1., Inm, Dnm);
		Dltp2[i] = angdif(1., Ip[i], Dp[i], 1., Ipnm, Dpnm);
		Dltv2[i] = angdif(1., Vlt[Id[i]], Vln[Id[i]], 1., Vtnm, Vnnm);
		break;
	case 1:
		vgpadf(Slt[Id[i]], Sln[Id[i]], Nplt, Npln, &dumi, &dumd);
		Dlt[i] = angdif(1., Is[Id[i]], Ds[Id[i]], 1., dumi, dumd);
		Dltp[i] = angdif(1., Ip[i], Dp[i], 1., 90., 0.);
		Dltv[i] = angdif(1., Vlt[Id[i]], Vln[Id[i]], 1., Nplt, Npln);
		Dlt2[i] = Dlt[i];
		Dltp2[i] = Dltp[i];
		Dltv2[i] = Dltv[i];
		break;
	default:
		error("delta_normal: error in mode!");
	}
}

void delta_reverse(i, mode)
int i, mode;		/* mode: delta from 0--mean, 1--apparent north pole */
{
	double dumi, dumd, ip0, dp0, vt0, vn0;

	switch (mode){
	case 0:
		Dlt[i] = angdif(1., Is[Id[i]], Ds[Id[i]], 1., -Im, Dm - 180.);
		Dltp[i] = angdif(1., Ip[i], Dp[i], 1., -Ipm, Dpm - 180.);
		Dltv[i] = angdif(1., Vlt[Id[i]], Vln[Id[i]], 1., -Vtm, Vnm - 180.);
		Dlt2[i] = angdif(1., Is[Id[i]], Ds[Id[i]], 1., Ism, Dsm);
		Dltp2[i] = angdif(1., Ip[i], Dp[i], 1., Ipsm, Dpsm);
		Dltv2[i] = angdif(1., Vlt[Id[i]], Vln[Id[i]], 1., Vtsm, Vnsm);
		break;
	case 1:
		vgpadf(Slt[Id[i]], Sln[Id[i]], -Nplt, Npln - 180., &dumi, &dumd);
		Dlt[i] = angdif(1., Is[Id[i]], Ds[Id[i]], 1., dumi, dumd);
		Dltp[i] = angdif(1., Ip[i], Dp[i], 1., -90., 180.);
		Dltv[i] = angdif(1., Vlt[Id[i]], Vln[Id[i]], 1., -Nplt, Npln - 180.);
		Dlt2[i] = Dlt[i];
		Dltp2[i] = Dltp[i];
		Dltv2[i] = Dltv[i];
		break;
	default:
		error("delta_reverse: error in mode!");
	}
}

/* cal_asd & asd_summ2 */

void cal_asd()
{
	int i, j = 0;

	St = Stn = Sts = Stp = Stpn = Stps = Stv = Stvn = Stvs = 0.;
	for (i = 0; i < Nsite; i++){
		if (Rjc[i] == 1) continue;
		St += Dlt[j]*Dlt[j];
		Stp += Dltp[j]*Dltp[j];
		Stv += Dltv[j]*Dltv[j];
		if ( !(Opt & ASD_NPOLE) ){
			if (vecumuls(Vlt[Id[i]],Vln[Id[i]],Vtm,Vnm) >= 0.)
				asd_summ2(j, &Stn, &Stpn, &Stvn);
			else
				asd_summ2(j, &Sts, &Stps, &Stvs);
		}
		else {
			if (vecumuls(Vlt[Id[i]],Vln[Id[i]],Nplt,Npln) >= 0.)
				asd_summ2(j, &Stn, &Stpn, &Stvn);
			else
				asd_summ2(j, &Sts, &Stps, &Stvs);
		}
		j++;
	}
}

void asd_summ2(j, s, sp, sv)
int j;
double *s, *sp, *sv;
{
	*s += Dlt2[j]*Dlt2[j];
	*sp += Dltp2[j]*Dltp2[j];
	*sv += Dltv2[j]*Dltv2[j];
}

/* pst_rejectf -- reject the farthest VGP from the present statistics,
	corresponding (inc,dec) & (incp,dec) are also rejected
*/

void pst_rejectf(n)
int n;
{
	int i, k = 0, imax = 0;
	double dltvmax = 0.;

	if (Nstat <= 2) return;
	for (i = 0; i < Nsite; i++){
		if (Rjc[i] == 1) continue;
		if (Dltv[i] >= dltvmax){
			dltvmax = Dltv[i];
			imax = i;
		}
		k++;
	}
	Rjc[imax] = 1;
	Nstat = k - 1;
}

/* pst_restorf -- restore the nearest VGP and directions to the present statistics */

void pst_restorf(n)
int n;
{
	int i, k = 0, imin = 0;
	double dltvmin = 180.;

	if (Nstat >= Nsite) return;
	for (i = 0; i < Nsite; i++){
		if (Rjc[i] == 0){
			k++;
			continue;
		}
		if (Dltv[i] <= dltvmin){
			dltvmin = Dltv[i];
			imin = i;
		}
	}
	Rjc[imin] = 0;
	Nstat = k + 1;
}
