#include <string.h>
#include "pstat.h"

#define CNTMAPV	" -JA%.0f/%.0f/11 -R0/360/%.0f/%.0f"
#define TICKV	" -Ba90g30/g30"
#define XYV	" -X8.5 -Y2.0"
#define CONT	"%.1f %.1f\n"

extern FILE *Fpt;
extern char Buf[WBUF];
extern unsigned int Opt;
extern int Nsite, *Id, *Rjc, Nnm, Nsm;
extern double *Slt, *Sln, Sltm, Slnm, Mapln, *Vlt, *Vln, *Vlnr;
extern double Vtm, Vnm, Vnmr, Vtnm, Vnnm, Vnnmr, Vtsm, Vnsm, Vnsmr, A95vm, A95vnm, A95vsm;

/* pst_vgp -- draw a world map with VGPs */

void pst_vgp(n)
int n;
{
	char mapv[100];
	int i;

	/* world map */

	if ( !(Opt & SOUTH_HEMI) )
		sprintf(mapv, CNTMAPV, Mapln, 90., 0., 90.);
	else
		sprintf(mapv, CNTMAPV, Mapln, -90., -90., 0.);
	sys_call(8, "gmt pscoast", mapv, TICKV, GREY, " -Dc -A500/1", XYV, " -P -K >", FILEP);

	/* site localities */

	if (Opt & SHOW_SITE){
		if ( !(Opt & SHOW_DIST_SITE) ){
			sprintf(Buf, CONT, Slnm, Sltm);   wrt_tmp();
		}
		else
			wrt_tmp2(Id[0], Id[Nsite-1], CONT, Sln, Slt);
		sys_call(6, "gmt psxy ", FILET, mapv, STAR3O, " -P -O -K >>", FILEP);
	}

	/* plot each VGP */

	for (i = 0; i < Nsite; i++){
		if (Rjc[i] == 0){
			sprintf(Buf, CONT, Vln[Id[i]], Vlt[Id[i]]);   wrt_tmp();
			sys_call(6, "gmt psxy ", FILET, mapv, CIRC2S, " -P -O -K >>", FILEP);
			sprintf(Buf, CONT, Vlnr[i], -Vlt[Id[i]]);   wrt_tmp();
			sys_call(6, "gmt psxy ", FILET, mapv, CIRC2O, " -P -O -K >>", FILEP);
		}
		else {
			sprintf(Buf, CONT, Vln[Id[i]], Vlt[Id[i]]);   wrt_tmp();
			sys_call(6, "gmt psxy ", FILET, mapv, CIRC2SG, " -P -O -K >>", FILEP);
			sprintf(Buf, CONT, Vlnr[i], -Vlt[Id[i]]);   wrt_tmp();
			sys_call(6, "gmt psxy ", FILET, mapv, CIRC2OG, " -P -O -K >>", FILEP);
		}
	}

	/* plot a mean VGP & a circle of A95 */

	if (Opt & MEAN_VGP){
		if ( !(Opt & SEPARATE_NS) ){
			if ( !(Opt & SOUTH_HEMI) ){
				sprintf(Buf, CONT, Vnm, Vtm);   wrt_tmp();
/*				sys_call(6, "gmt psxy ", FILET, mapv, CIRC3S, " -P -O -K >>", FILEP); */
				sys_call(6, "gmt psxy ", FILET, mapv, CIRC3SR, " -P -O -K >>", FILEP);
				pst_a95v(Vtm, Vnm, A95vm, 64, 0);
/*				sys_call(6, "gmt psxy ", FILET, mapv, PEN3S, " -P -O -K >>", FILEP); */
				sys_call(6, "gmt psxy ", FILET, mapv, PEN3SR, " -P -O -K >>", FILEP);
				pst_a95v(Vtm, Vnm, A95vm, 64, 1);
/*				sys_call(6, "gmt psxy ", FILET, mapv, PEN3D, " -P -O -K >>", FILEP); */
				sys_call(6, "gmt psxy ", FILET, mapv, PEN3DR, " -P -O -K >>", FILEP);
			}
			else {
				sprintf(Buf, CONT, Vnmr, -Vtm);   wrt_tmp();
/*				sys_call(6, "gmt psxy ", FILET, mapv, CIRC3S, " -P -O -K >>", FILEP); */
				sys_call(6, "gmt psxy ", FILET, mapv, CIRC3SR, " -P -O -K >>", FILEP);
				pst_a95v(-Vtm, Vnmr, A95vm, 64, 0);
/*				sys_call(6, "gmt psxy ", FILET, mapv, PEN3S, " -P -O -K >>", FILEP); */
				sys_call(6, "gmt psxy ", FILET, mapv, PEN3SR, " -P -O -K >>", FILEP);
				pst_a95v(-Vtm, Vnmr, A95vm, 64, 1);
/*				sys_call(6, "gmt psxy ", FILET, mapv, PEN3D, " -P -O -K >>", FILEP); */
				sys_call(6, "gmt psxy ", FILET, mapv, PEN3DR, " -P -O -K >>", FILEP);
			}
		}
		else {
			if ( !(Opt & SOUTH_HEMI) ){
				if (Nnm > 0){
					sprintf(Buf, CONT, Vnnm, Vtnm);   wrt_tmp();
/*					sys_call(6, "gmt psxy ", FILET, mapv, CIRC3S, " -P -O -K >>", FILEP); */
					sys_call(6, "gmt psxy ", FILET, mapv, CIRC3SR, " -P -O -K >>", FILEP);
					pst_a95v(Vtnm, Vnnm, A95vnm, 64, 0);
/*					sys_call(6, "gmt psxy ", FILET, mapv, PEN3S, " -P -O -K >>", FILEP); */
					sys_call(6, "gmt psxy ", FILET, mapv, PEN3SR, " -P -O -K >>", FILEP);
					pst_a95v(Vtnm, Vnnm, A95vnm, 64, 1);
/*					sys_call(6, "gmt psxy ", FILET, mapv, PEN3D, " -P -O -K >>", FILEP); */
					sys_call(6, "gmt psxy ", FILET, mapv, PEN3DR, " -P -O -K >>", FILEP);
				}
				if (Nsm > 0){
					sprintf(Buf, CONT, Vnsmr, -Vtsm);   wrt_tmp();
/*					sys_call(6, "gmt psxy ", FILET, mapv, CIRC3O, " -P -O -K >>", FILEP); */
					sys_call(6, "gmt psxy ", FILET, mapv, CIRC3OR, " -P -O -K >>", FILEP);
					pst_a95v(-Vtsm, Vnsmr, A95vsm, 64, 0);
/*					sys_call(6, "gmt psxy ", FILET, mapv, PEN3D, " -P -O -K >>", FILEP); */
					sys_call(6, "gmt psxy ", FILET, mapv, PEN3DR, " -P -O -K >>", FILEP);
					pst_a95v(-Vtsm, Vnsmr, A95vsm, 64, 1);
/*					sys_call(6, "gmt psxy ", FILET, mapv, PEN3D, " -P -O -K >>", FILEP); */
					sys_call(6, "gmt psxy ", FILET, mapv, PEN3DR, " -P -O -K >>", FILEP);
				}
			}
			else {
				if (Nsm > 0){
					sprintf(Buf, CONT, Vnsm, Vtsm);   wrt_tmp();
/*					sys_call(6, "gmt psxy ", FILET, mapv, CIRC3S, " -P -O -K >>", FILEP); */
					sys_call(6, "gmt psxy ", FILET, mapv, CIRC3SR, " -P -O -K >>", FILEP);
					pst_a95v(Vtsm, Vnsm, A95vsm, 64, 0);
/*					sys_call(6, "gmt psxy ", FILET, mapv, PEN3S, " -P -O -K >>", FILEP); */
					sys_call(6, "gmt psxy ", FILET, mapv, PEN3SR, " -P -O -K >>", FILEP);
					pst_a95v(Vtsm, Vnsm, A95vsm, 64, 1);
/*					sys_call(6, "gmt psxy ", FILET, mapv, PEN3D, " -P -O -K >>", FILEP); */
					sys_call(6, "gmt psxy ", FILET, mapv, PEN3DR, " -P -O -K >>", FILEP);
				}
				if (Nnm > 0){
					sprintf(Buf, CONT, Vnnmr, -Vtnm);   wrt_tmp();
/*					sys_call(6, "gmt psxy ", FILET, mapv, CIRC3O, " -P -O -K >>", FILEP); */
					sys_call(6, "gmt psxy ", FILET, mapv, CIRC3OR, " -P -O -K >>", FILEP);
					pst_a95v(-Vtnm, Vnnmr, A95vnm, 64, 0);
/*					sys_call(6, "gmt psxy ", FILET, mapv, PEN3D, " -P -O -K >>", FILEP); */
					sys_call(6, "gmt psxy ", FILET, mapv, PEN3DR, " -P -O -K >>", FILEP);
					pst_a95v(-Vtnm, Vnnmr, A95vnm, 64, 1);
/*					sys_call(6, "gmt psxy ", FILET, mapv, PEN3D, " -P -O -K >>", FILEP); */
					sys_call(6, "gmt psxy ", FILET, mapv, PEN3DR, " -P -O -K >>", FILEP);
				}
			}
		}
	}
}

/* pst_a95v */

int pst_a95v(plat, plon, a95, na, flip)
int na, flip;
double plat, plon, a95;
{
	int i;
	double vlat[NAMAX+1], vlon[NAMAX+1];

	if ((Fpt = fopen(FILET, "w")) == NULL) error("pst_a95v: error of open a TMP file!");
	if (alph95(plat, plon, a95, na, vlat, vlon) == -1) return(-1);
	if (flip == 0)
		for (i = 0; i <= na; i++)
			fprintf(Fpt, CONT, vlon[i], vlat[i]);
	else if (flip == 1)
		for (i = 0; i <= na; i++)
			fprintf(Fpt, CONT, vlon[i], -vlat[i]);
	else
		error("pst_a95v: wrong flip!");
	fclose(Fpt);
	return(1);
}
#undef CNTMAPV
#undef TICKV
#undef XYV
#undef CONT
