/* pstat -- Statistics of site mean paleodirections
	V.1.1: adapted to use GMT 5.2.1 & adopted commands common to other pmag progs  061218
	V.1.0: For the details, see the HELP message in pst_cmd()   101303
*/

#define COMMAND "+,-,0,9,C,G,U,A,V,D,R,S,X,P,H,Q?"
#define HELPCMD "Commands:\n\
  \e[1m+\e[m-next, \e[1m-\e[m-back, \e[1m0\e[m-first, \e[1m9\e[m-last, lo\e[1mC\e[mality-on/on2/off, map-lon\e[1mG\e[mitude,\n\
  so\e[1mU\e[mthern-hemi-on/off, \e[1mA\e[mlph95-on/off, di\e[1mV\e[mide-ns-on/off, \e[1mD\e[melete-one, \e[1mR\e[mestore-one,\n\
  a\e[1mS\e[md-pole, a\e[1mX\e[mial-dpf-on/off, \e[1mP\e[msfile, \e[1mH\e[melp, \e[1mQ\e[muit"

#include <ctype.h>
#include "pstat.h"

FILE *Fpt;
char **Group, **Site, Filed[WFILE], Buf[WBUF];
unsigned int Opt = 0;
int Ngrp, Nsite, Nstat, *Idsite, *Id, *Rjc, Nm, Nnm, Nsm;
double *Slt, *Sln, Sltm, Slnm, Mapln, Nplt, Npln, *Is, *Ds, *A95, *Nsmpl, *R, *K, \
	*Vlt, *Vln, *Sw, *Swv;
double *Dq, *Ip, *Dp, *Dqp, *Vlnr, *Dlt, *Dltp, *Dltv, *Dlt2, *Dltp2, *Dltv2;
double Im, Dm, Inm, Dnm, Ism, Dsm, Ipm, Dpm, Ipnm, Dpnm, Ipsm, Dpsm, Vtm, Vnm, Vnmr, \
	Vtnm, Vnnm, Vnnmr, Vtsm, Vnsm, Vnsmr, A95m, A95nm, A95sm, A95pm, A95pnm, A95psm, \
	A95vm, A95vnm, A95vsm, Rm, Rnm, Rsm, Rpm, Rpnm, Rpsm, Rvm, Rvnm, Rvsm, Km, Knm, Ksm, \
	Kpm, Kpnm, Kpsm, Kvm, Kvnm, Kvsm;
double Nwm, Nwnm, Nwsm, Swm, Swnm, Swsm, Swvm, Swvnm, Swvsm, Sb, Sbn, Sbs, Sbp, \
	Sbpn, Sbps, Sbv, Sbvn, Sbvs, St, Stn, Sts, Stp, Stpn, Stps, Stv, Stvn, Stvs;

int main(argc, argv)
int argc;
char *argv[];
{
	FILE *fpr, *pst_cmd();
	int n = 0, c, ntsite;

	Opt |= SHOW_SITE;   Opt |= ALPH_FLD;   Opt |= MEAN_VGP;
	Nplt = 90.;   Npln = 0.;
	if ((fpr = pst_cmd(argc, argv, Filed)) == NULL) error("Error in fopen!");
	pst_dat(fpr, &ntsite);
	fclose(fpr);
	fprintf(stdout, "Fisher statistics from %s\n", Filed);
	do_init(n);
	sys_call(3, "evince ", FILEP, " &");
/*	sys_call(3, "gv -nodsc -watch -scale=0.7 ", FILEP, " &"); */
/*	sys_call(3, "gv -nodsc -watch ", FILEP, " &"); */
/*	sys_call(3, "gv --nodsc --watch ", FILEP, " &"); */
	while ((c = pst_comd(COMMAND)) != ZERO){
		switch(toupper(c)){
		case '+':
			go_next(&n); break;
		case '-':
			go_back(&n); break;
		case '0':
			go_first(&n); break;
		case '9':
			go_last(&n); break;
		case 'C':
			plot_locality(n); break;
		case 'G':
			map_longitude(n); break;
		case 'U':
			south_hemi(n); break;
		case 'A':
			alph_on_off(n); break;
		case 'V':
			divide_ns(n); break;
		case 'D':
			delete_one(n); break;
		case 'R':
			restor_one(n); break;
		case 'S':
			asd_north_pole(n); break;
		case 'X':
			axial_dpf(n); break;
		case 'P':
			out_psfile(n); break;
		case 'H':
			fprintf(stdout, "%s\n", HELPCMD); break;
		default:
			break;
		}
	}
/*	free_all(Ngrp, ntsite); */
	quit_gv();
	sys_call(2, "rm -f ", FILET);
}

/* quit_gv -- force to kill the running Ghost View */

void quit_gv()
{
	FILE *fp;
	char *file1 = "PSTAT.TM2", *file2 = "PSTAT.TM3", s1[20];

	sys_call(2, "ps a >", file1);
	sys_call(4, "grep \"evince\" ", file1, " >", file2);
/*	sys_call(4, "grep \"gv -nodsc -watch -scale=0.7\" ", file1, " >", file2); */
/*	sys_call(4, "grep \"gv -nodsc -watch\" ", file1, " >", file2); */
/*	sys_call(4, "grep \"gv --nodsc --watch\" ", file1, " >", file2); */
	if ((fp = fopen(file2, "r")) == NULL) error("Error at quit_gv!");
	get_s(fp, 1, s1);
	fclose(fp);
	sys_call(2, "kill ", s1);
	sys_call(2, "rm -f ", file1);   sys_call(2, "rm -f ", file2);
}
#undef COMMAND
#undef HELPCMD
