/* pstat.h -- header file for pstat */

#include "std.h"

/* general definitions, etc. */

#define FILEP	"PSTAT.PS"
#define FILET	"PSTAT.TMP"

#define WFILE	100	/* maximum length of data file name */
#define WGRP	50	/* maximum length of group name */
#define WSITE	50	/* maximum length of site name */
#define WBUF	1000	/* maximum length of Buf used by wrt_tmp */
#define NAMAX	64	/* maximum number of points to draw a95 */
#define ZERO	0

/* For use by unsigned int Opt */

#define SHOW_SITE	1
#define SHOW_DIST_SITE	2
#define ALPH_FLD	4
#define ALPH_VGP	8	/* Not in use for the moment */
#define MEAN_FLD	16
#define MEAN_VGP	32
#define SEPARATE_NS	64
#define SOUTH_HEMI	128
#define AXIAL_DPF	256
#define ASD_NPOLE	512
#define MAP_LONG	1024

/* GMT options */
#define PEN2S   " -W0.25p,black"
#define PEN2D   " -W0.25p,black,2_2:0"
#define PEN2SG  " -W0.25p,132"
#define PEN2DG  " -W0.25p,132,2_2:0"
#define PEN3S   " -W0.5p,black"
#define PEN3SR  " -W0.5p,red"
#define PEN3D   " -W0.5p,black,2_2:0"
#define PEN3DR  " -W0.5p,red,2_2:0"
#define PEN3SG  " -W0.5p,132"
#define PEN3DG  " -W0.5p,132,2_2:0"
#define PEN5S   " -W1.0p,black"
#define PEN5D   " -W1.0p,black,5_5:0"
#define PEN5SG  " -W1.0p,132"
#define PEN5DG  " -W1.0p,132,5_5:0"

#define CIRC2S  " -Sc0.2c -G0 -W1.0p,black"
#define CIRC2SG " -Sc0.2c -G132 -W1.0p,132"
#define CIRC2O  " -Sc0.2c -G255 -W1.0p,black"
#define CIRC2OG " -Sc0.2c -G255 -W1.0p,132"
#define CIRC3S  " -Sc0.3c -G0 -W1.0p,black"
#define CIRC3SR " -Sc0.3c -Gred -W1.0p,red"
#define CIRC3O  " -Sc0.3c -G255 -W1.0p,black"
#define CIRC3OR " -Sc0.3c -G255 -W1.0p,red"
#define TRIA2S  " -St0.2c -G0 -W1.0p,black"
#define TRIA2O  " -St0.2c -G255 -W1.0p,black"
#define CROS2S  " -Sx0.2c -G0 -W1.0p,black"
#define CROS2D  " -Sx0.2c -G132 -W1.0p,132,2_2:0"
#define STAR3O  " -Sa0.3c -G255 -W1.0p,black"

#define GREY	" -G220"
#define OPTF	" -F+f+j"

/* Type of functions */

void quit_gv();
FILE *pst_cmd();
int pst_comd(); void do_init(), go_next(), go_back(), go_first(), go_last(), plot_locality(), \
	map_longitude(), south_hemi(), alph_on_off(), divide_ns(), delete_one(), \
	restor_one(), asd_north_pole(), axial_dpf(), out_psfile();
void pst_dat(), pst_grpdat(), pst_mem1(), pst_mem2(), free_all();
void pst_fld(); int pst_a95f();
void pst_fld_dp();
void pst_plot(), wrt_tmp(), wrt_tmp2(), wrt_tmp3(), wrt_tmp3i();
void pst_results();
void pst_statf(), set_one_site(), set_one_normal(), set_one_reverse(), summ_data(), \
	summ_normal(), summ_reverse(), statf_result(), cal_delta(), delta_normal(), \
	delta_reverse(), cal_asd(), asd_summ2(), pst_rejectf(), pst_restorf();
void pst_text();
void pst_vgp(); int pst_a95v();
