#include <string.h>
#include "psvar.h"

#define MAPF	" -JA180/90/11.0"
#define TICKF	" -Bg90"
#define RANGEF	" -R0/360/0/90"
#define XYF	" -Y13.5"
#define CONT	"%.1f %.1f\n"
#define CNUMBR  "%.4f %.4f 9p,Helvetica,blue BL %d\n"
#define CSITEID "%.4f %.4f 9p,Helvetica,blue BL %s\n"
#define MAPTXT	" -Jx1 -R0/12.0/0/12.0"
#define TEXTEQ	" 5.5  11.1 14p,Helvetica,black CB 0\n\
11.1   5.5 14p,Helvetica,black LM 90\n\
 5.5  -0.1 14p,Helvetica,black CT 180\n\
-0.1   5.5 14p,Helvetica,black RM 270\n"

extern FILE *Fpt;
extern char Buf[WBUF], **Site, *Frame_lbl[];
extern unsigned int Opt;
extern int Ngrp, Nsite, Nstat, *Numbr, *Id;
extern double *Is, *Ds, *Ig, *Dg, *A95, Im, Dm, A95m;

/* psv_fld -- plot in situ (or tilted) paleodirections for n th site */

void psv_fld(n)
int n;
{
	int i, i1, i2;

	/* base map */

	sys_call(7, "gmt psbasemap", MAPF, TICKF, RANGEF, XYF, " -P -O -K >>", FILEP);

	/* plot each field direction */

	if (n == 0){
		if (Opt & SHOW_PRE_POST){ i1 = 0;   i2 = Nsite; }
		else { i1 = 0;   i2 = Nsite-1; }
		if (Opt & PLOT_SITEID){
			wrt_tmp3c(i1, i2, CSITEID, Dg+Id[0], Is+Id[0], Site+Id[0]);
			sys_call(8, "gmt pstext ", FILET, MAPF, RANGEF, DSHIFT4, OPTF, \
				" -P -O -K >>", FILEP);
			wrt_tmp3c(i1, i2, CSITEID, Dg+Id[0], Ig+Id[0], Site+Id[0]);
			sys_call(8, "gmt pstext ", FILET, MAPF, RANGEF, DSHIFT4, OPTF, \
				" -P -O -K >>", FILEP);
		}
		else if (Opt & PLOT_NUMBER){
			wrt_tmp3i(i1, i2, CNUMBR, Dg+Id[0], Is+Id[0], Numbr+Id[0]);
			sys_call(8, "gmt pstext ", FILET, MAPF, RANGEF, DSHIFT4, OPTF, \
				" -P -O -K >>", FILEP);
			wrt_tmp3i(i1, i2, CNUMBR, Dg+Id[0], Ig+Id[0], Numbr+Id[0]);
			sys_call(8, "gmt pstext ", FILET, MAPF, RANGEF, DSHIFT4, OPTF, \
				" -P -O -K >>", FILEP);
		}
		if (Opt & PLOT_ALPH){
			for (i=i1; i<=i2; i++){
				psv_a95f(Is[Id[0]+i], Ds[Id[0]+i], A95[Id[0]+i], 64, 0);
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2S, \
					" -P -O -K >>", FILEP);
				psv_a95f(Is[Id[0]+i], Ds[Id[0]+i], A95[Id[0]+i], 64, 1);
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2D, \
					" -P -O -K >>", FILEP);
			}
		}
		wrt_tmp2(i1, i2, CONT, Dg+Id[0], Is+Id[0]);
		if (Opt & PLOT_PATH){
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3S, " -P -O -K >>", FILEP);
		}
		sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC2S, " -P -O -K >>", FILEP);
		wrt_tmp2(i1, i2, CONT, Dg+Id[0], Ig+Id[0]);
		if (Opt & PLOT_PATH){
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3D, " -P -O -K >>", FILEP);
		}
		sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC2O, " -P -O -K >>", FILEP);
	}
	else if (n == Ngrp-1){
		if (Opt & SHOW_PRE_POST){ i1 = 0;   i2 = Nsite; }
		else { i1 = 1;   i2 = Nsite; }
		if (Opt & PLOT_SITEID){
			wrt_tmp3c(i1, i2, CSITEID, Dg+Id[0]-1, Is+Id[0]-1, Site+Id[0]-1);
			sys_call(8, "gmt pstext ", FILET, MAPF, RANGEF, DSHIFT4, OPTF, \
				" -P -O -K >>", FILEP);
			wrt_tmp3c(i1, i2, CSITEID, Dg+Id[0]-1, Ig+Id[0]-1, Site+Id[0]-1);
			sys_call(8, "gmt pstext ", FILET, MAPF, RANGEF, DSHIFT4, OPTF, \
				" -P -O -K >>", FILEP);
		}
		else if (Opt & PLOT_NUMBER){
			wrt_tmp3i(i1, i2, CNUMBR, Dg+Id[0]-1, Is+Id[0]-1, Numbr+Id[0]-1);
			sys_call(8, "gmt pstext ", FILET, MAPF, RANGEF, DSHIFT4, OPTF, \
				" -P -O -K >>", FILEP);
			wrt_tmp3i(i1, i2, CNUMBR, Dg+Id[0]-1, Ig+Id[0]-1, Numbr+Id[0]-1);
			sys_call(8, "gmt pstext ", FILET, MAPF, RANGEF, DSHIFT4, OPTF, \
				" -P -O -K >>", FILEP);
		}
		if (Opt & PLOT_ALPH){
			for (i=i1; i<=i2; i++){
				psv_a95f(Is[Id[0]-1+i], Ds[Id[0]-1+i], A95[Id[0]-1+i], 64, 0);
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2S, \
					" -P -O -K >>", FILEP);
				psv_a95f(Is[Id[0]-1+i], Ds[Id[0]-1+i], A95[Id[0]-1+i], 64, 1);
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2D, \
					" -P -O -K >>", FILEP);
			}
		}
		wrt_tmp2(i1, i2, CONT, Dg+Id[0]-1, Is+Id[0]-1);
		if (Opt & PLOT_PATH){
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3S, " -P -O -K >>", FILEP);
		}
		sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC2S, " -P -O -K >>", FILEP);
		wrt_tmp2(i1, i2, CONT, Dg+Id[0]-1, Ig+Id[0]-1);
		if (Opt & PLOT_PATH){
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3D, " -P -O -K >>", FILEP);
		}
		sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC2O, " -P -O -K >>", FILEP);
	}
	else {
		if (Opt & SHOW_PRE_POST){ i1 = 0;   i2 = Nsite+1; }
		else { i1 = 1;   i2 = Nsite; }
		if (Opt & PLOT_SITEID){
			wrt_tmp3c(i1, i2, CSITEID, Dg+Id[0]-1, Is+Id[0]-1, Site+Id[0]-1);
			sys_call(8, "gmt pstext ", FILET, MAPF, RANGEF, DSHIFT4, OPTF, \
				" -P -O -K >>", FILEP);
			wrt_tmp3c(i1, i2, CSITEID, Dg+Id[0]-1, Ig+Id[0]-1, Site+Id[0]-1);
			sys_call(8, "gmt pstext ", FILET, MAPF, RANGEF, DSHIFT4, OPTF, \
				" -P -O -K >>", FILEP);
		}
		else if (Opt & PLOT_NUMBER){
			wrt_tmp3i(i1, i2, CNUMBR, Dg+Id[0]-1, Is+Id[0]-1, Numbr+Id[0]-1);
			sys_call(8, "gmt pstext ", FILET, MAPF, RANGEF, DSHIFT4, OPTF, \
				" -P -O -K >>", FILEP);
			wrt_tmp3i(i1, i2, CNUMBR, Dg+Id[0]-1, Ig+Id[0]-1, Numbr+Id[0]-1);
			sys_call(8, "gmt pstext ", FILET, MAPF, RANGEF, DSHIFT4, OPTF, \
				" -P -O -K >>", FILEP);
		}
		if (Opt & PLOT_ALPH){
			for (i=i1; i<=i2; i++){
				psv_a95f(Is[Id[0]-1+i], Ds[Id[0]-1+i], A95[Id[0]-1+i], 64, 0);
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2S, \
					" -P -O -K >>", FILEP);
				psv_a95f(Is[Id[0]-1+i], Ds[Id[0]-1+i], A95[Id[0]-1+i], 64, 1);
				sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN2D, \
					" -P -O -K >>", FILEP);
			}
		}
		wrt_tmp2(i1, i2, CONT, Dg+Id[0]-1, Is+Id[0]-1);
		if (Opt & PLOT_PATH){
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3S, " -P -O -K >>", FILEP);
		}
		sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC2S, " -P -O -K >>", FILEP);
		wrt_tmp2(i1, i2, CONT, Dg+Id[0]-1, Ig+Id[0]-1);
		if (Opt & PLOT_PATH){
			sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3D, " -P -O -K >>", FILEP);
		}
		sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC2O, " -P -O -K >>", FILEP);
	}

	/* plot the mean directions with circle of A95 for normal and reversed separately */

	if (Opt & PLOT_MEAN){
		psv_a95f(Im, Dm, A95m, 64, 0);
		sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3SR, " -P -O -K >>", FILEP);
		psv_a95f(Im, Dm, A95m, 64, 1);
		sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, PEN3DR, " -P -O -K >>", FILEP);
		sprintf(Buf, CONT, 360. - Dm, Im);   wrt_tmp();
		sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC3SR, " -P -O -K >>", FILEP);
		sprintf(Buf, CONT, 360. - Dm, -Im);   wrt_tmp();
		sys_call(7, "gmt psxy ", FILET, MAPF, RANGEF, CIRC3OR, " -P -O -K >>", FILEP);
	}

	/* plot labels */

	sprintf(Buf, TEXTEQ);   wrt_tmp();
	sys_call(6, "gmt pstext ", FILET, MAPTXT, OPTF, " -N -P -O -K >>", FILEP);
}

/* psv_a95f */

int psv_a95f(inc, dec, a95, na, flip)
int na, flip;
double inc, dec, a95;
{
	int i;
	double inca[NAMAX+1], deca[NAMAX+1];

	if ((Fpt = fopen(FILET, "w")) == NULL) error("psv_a95f: error of open a TMP file!");
	if (alph95(inc, dec, a95, na, inca, deca) == -1) return(-1);
	if (flip == 0)
		for (i = 0; i <= na; i++)
			fprintf(Fpt, CONT, 360. - deca[i], inca[i]);
	else if (flip == 1)
		for (i = 0; i <= na; i++)
			fprintf(Fpt, CONT, 360. - deca[i], -inca[i]);
	fclose(Fpt);
	return(1);
}
#undef MAPF
#undef TICKF
#undef RANGEF
#undef XYF
#undef CONT
#undef CNUMBR
#undef CSITEID
#undef MAPTXT
#undef TEXTEQ
