#include <string.h>
#include "psvar.h"

#define CNT0	"Paleomagnetic Statistics by PSVAR\n\nGroup: %s (File: %s)\n\n\
  N0  Slat   Slon   NPlat  NPlon  Center_ASD\n\
 %3d %6.2f %6.2f %6.2f %6.2f  %s\n\n"
#define CNTV	"VGP:\n\
   N  Plat   Plon    A95    R        k      S      St     Sw     Nw\n\
 %3d %6.2f %6.2f %6.2f %7.4f %7.2f %6.2f %6.2f %6.2f %6.2f\n"
#define CNTF	"%s:\n\
  Incm   Decm    a95    R        k      S      St     Sw\n\
 %6.2f %6.2f %6.2f %7.4f %7.2f %6.2f %6.2f %6.2f\n"
#define CNTD0	"\nsite        vlat  vlon   A95  dltv   I     D    a95   dlt   \
N   Sw   Swv   slat  slon\n"
#define CNTD	"%-10s %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f \
%2.0f %5.1f %5.1f %5.1f %5.1f\n"

extern char Filed[WFILE], **Group, **Site;
extern unsigned int Opt;
extern int Nsite, Nm, *Id;
extern double Im, Dm, Vtm, Vnm, A95m, A95vm, Rm, Rvm, Km, Kvm, Sltm, Slnm, \
	Nplt, Npln, Nwm, Swm, Swvm, Sb, Sbv, St, Stv, *Slt, *Sln, *Is, *Ds, \
	*A95, *Nsmpl, *Vlt, *Vln, *A95v, *Sw, *Swv, *Dlt, *Dltv;

/* psv_results -- write detailed results of the Fisher statistics to "group_name.PSV" */

void psv_results(n)
int n;
{
	FILE *fp;
	char filer[WFILE], sdum[15];
	int i;

	strcpy(filer, Group[n]);   strcat(filer, ".PSV");
	if ((fp = fopen(filer, "w")) == NULL) error("psv_results: error of fopen!");
	if ( !(Opt & ASD_NPOLE) ) strcpy(sdum, "MEAN");
	else strcpy(sdum, "FIXED POLE");
	fprintf(fp, CNT0, Group[n], Filed, Nsite, Sltm, Slnm, Nplt, Npln, sdum);
	fprintf(fp, CNTV, Nm, Vtm, Vnm, A95vm, Rvm, Kvm, Sbv, Stv, Swvm, Nwm);
	fprintf(fp, CNTF, "Field", Im, Dm, A95m, Rm, Km, Sb, St, Swm);
	fprintf(fp, CNTD0);
	for (i = 0; i < Nsite; i++)
		fprintf(fp, CNTD, Site[Id[i]], Vlt[Id[i]], Vln[Id[i]], A95v[Id[i]], Dltv[i], \
			Is[Id[i]], Ds[Id[i]], A95[Id[i]], Dlt[i], Nsmpl[Id[i]], Sw[Id[i]], \
			Swv[Id[i]], Slt[Id[i]], Sln[Id[i]]);
	fclose(fp);
}
#undef CNT0
#undef CNTV
#undef CNTF
#undef CNTD0
#undef CNTD
