#include <string.h>
#include "psvar.h"

#define CNTMAPV	" -JA%.0f/%.0f/11 -R0/360/%.0f/%.0f"
#define TICKV	" -Ba90g30/g30"
#define XYV	" -X8.5 -Y2.0"
#define CONT	"%.1f %.1f\n"
#define CNUMBR	"%.4f %.4f 9p,Helvetica,blue BL %d\n"
#define CSITEID	"%.4f %.4f 9p,Helvetica,blue BL %s\n"

extern FILE *Fpt;
extern char Buf[WBUF], **Site;
extern unsigned int Opt;
extern int Ngrp, Nsite, *Numbr, *Id;
extern double *Slt, *Sln, Sltm, Slnm, Mapln, Mapltc, *Is, *Ds, *A95, *Vlt, *Vln, *A95v, Vtm, Vnm, A95vm;

/* psv_vgp -- draw a world map with VGPs */

void psv_vgp(n)
int n;
{
	char mapv[100];
	int i, i1, i2;

	/* world map */

	if (!(Opt & FIX_HEMI)){
		if (Vlt[Id[0]] >= 0.){
			if (Opt & SOUTH_HEMI) Opt &= ~SOUTH_HEMI;
		}
		else {
			if (!(Opt & SOUTH_HEMI)) Opt |= SOUTH_HEMI;
		}
	}
	if ( !(Opt & SOUTH_HEMI) )
		sprintf(mapv, CNTMAPV, Mapln, 90., Mapltc, 90.);
	else
		sprintf(mapv, CNTMAPV, Mapln, -90., -90., -Mapltc);
	if ( !(Opt & PLOT_STAMP) )
		sys_call(8, "gmt pscoast", mapv, TICKV, GREY, " -Dc -A500/1", XYV, " -P -K >", FILEP);
	else
		sys_call(8, "gmt pscoast", mapv, TICKV, GREY, " -Dc -A500/1", XYV, " -UTR/12/-0.5 -P -K >", FILEP);

	/* site localities */

	if (Opt & SHOW_SITE){
		if ( !(Opt & SHOW_DIST_SITE) ){
			sprintf(Buf, CONT, Slnm, Sltm);   wrt_tmp();
		}
		else
			wrt_tmp2(Id[0], Id[Nsite-1], CONT, Sln, Slt);
		sys_call(6, "gmt psxy ", FILET, mapv, STAR3O, " -P -O -K >>", FILEP);
	}

	/* plot each VGP */

	if (n == 0){
		if (Opt & SHOW_PRE_POST){ i1 = 0;   i2 = Nsite; }
		else { i1 = 0;   i2 = Nsite-1; }
		if (Opt & PLOT_SITEID){
			wrt_tmp3c(i1, i2, CSITEID, Vln+Id[0], Vlt+Id[0], Site+Id[0]);
/*			sys_call(7, "gmt pstext ", FILET, mapv, DSHIFT4, OPTF, " -N -P -O -K >>", FILEP); */
			sys_call(7, "gmt pstext ", FILET, mapv, DSHIFT4, OPTF, " -P -O -K >>", FILEP);
		}
		else if (Opt & PLOT_NUMBER){
			wrt_tmp3i(i1, i2, CNUMBR, Vln+Id[0], Vlt+Id[0], Numbr+Id[0]);
/*			sys_call(7, "gmt pstext ", FILET, mapv, DSHIFT4, OPTF, " -N -P -O -K >>", FILEP); */
			sys_call(7, "gmt pstext ", FILET, mapv, DSHIFT4, OPTF, " -P -O -K >>", FILEP);
		}
		if (Opt & PLOT_ALPH){
			for (i=i1; i<=i2; i++){
/*				psv_a95v2(Vlt[Id[0]+i], Vln[Id[0]+i], A95v[Id[0]+i], 64, 0); */
				psv_a95v(Slt[Id[0]+i], Sln[Id[0]+i], Is[Id[0]+i], Ds[Id[0]+i], A95[Id[0]+i], 64, 0);
				sys_call(6, "gmt psxy ", FILET, mapv, PEN2S, " -P -O -K >>", FILEP);
			}
		}
		wrt_tmp2(i1, i2, CONT, Vln+Id[0], Vlt+Id[0]);
		if (Opt & PLOT_PATH){
			sys_call(6, "gmt psxy ", FILET, mapv, PEN3S, " -P -O -K >>", FILEP);
		}
		sys_call(6, "gmt psxy ", FILET, mapv, CIRC2S, " -P -O -K >>", FILEP);
	}
	else if (n == Ngrp-1){
		if (Opt & SHOW_PRE_POST){ i1 = 0;   i2 = Nsite; }
		else { i1 = 1;   i2 = Nsite; }
		if (Opt & PLOT_SITEID){
			wrt_tmp3c(i1, i2, CSITEID, Vln+Id[0]-1, Vlt+Id[0]-1, Site+Id[0]-1);
/*			sys_call(7, "gmt pstext ", FILET, mapv, DSHIFT4, OPTF, " -N -P -O -K >>", FILEP); */
			sys_call(7, "gmt pstext ", FILET, mapv, DSHIFT4, OPTF, " -P -O -K >>", FILEP);
		}
		else if (Opt & PLOT_NUMBER){
			wrt_tmp3i(i1, i2, CNUMBR, Vln+Id[0]-1, Vlt+Id[0]-1, Numbr+Id[0]-1);
/*			sys_call(7, "gmt pstext ", FILET, mapv, DSHIFT4, OPTF, " -N -P -O -K >>", FILEP); */
			sys_call(7, "gmt pstext ", FILET, mapv, DSHIFT4, OPTF, " -P -O -K >>", FILEP);
		}
		if (Opt & PLOT_ALPH){
			for (i=i1; i<=i2; i++){
/*				psv_a95v2(Vlt[Id[0]-1+i], Vln[Id[0]-1+i], A95v[Id[0]-1+i], 64, 0); */
				psv_a95v(Slt[Id[0]-1+i], Sln[Id[0]-1+i], Is[Id[0]-1+i], Ds[Id[0]-1+i], A95[Id[0]-1+i], 64, 0);
				sys_call(6, "gmt psxy ", FILET, mapv, PEN2S, " -P -O -K >>", FILEP);
			}
		}
		wrt_tmp2(i1, i2, CONT, Vln+Id[0]-1, Vlt+Id[0]-1);
		if (Opt & PLOT_PATH){
			sys_call(6, "gmt psxy ", FILET, mapv, PEN3S, " -P -O -K >>", FILEP);
		}
		sys_call(6, "gmt psxy ", FILET, mapv, CIRC2S, " -P -O -K >>", FILEP);
	}
	else {
		if (Opt & SHOW_PRE_POST){ i1 = 0;   i2 = Nsite+1; }
		else { i1 = 1;   i2 = Nsite; }
		if (Opt & PLOT_SITEID){
			wrt_tmp3c(i1, i2, CSITEID, Vln+Id[0]-1, Vlt+Id[0]-1, Site+Id[0]-1);
/*			sys_call(7, "gmt pstext ", FILET, mapv, DSHIFT4, OPTF, " -N -P -O -K >>", FILEP); */
			sys_call(7, "gmt pstext ", FILET, mapv, DSHIFT4, OPTF, " -P -O -K >>", FILEP);
		}
		else if (Opt & PLOT_NUMBER){
			wrt_tmp3i(i1, i2, CNUMBR, Vln+Id[0]-1, Vlt+Id[0]-1, Numbr+Id[0]-1);
/*			sys_call(7, "gmt pstext ", FILET, mapv, DSHIFT4, OPTF, " -N -P -O -K >>", FILEP); */
			sys_call(7, "gmt pstext ", FILET, mapv, DSHIFT4, OPTF, " -P -O -K >>", FILEP);
		}
		if (Opt & PLOT_ALPH){
			for (i=i1; i<=i2; i++){
/*				psv_a95v2(Vlt[Id[0]-1+i], Vln[Id[0]-1+i], A95v[Id[0]-1+i], 64, 0); */
				psv_a95v(Slt[Id[0]-1+i], Sln[Id[0]-1+i], Is[Id[0]-1+i], Ds[Id[0]-1+i], A95[Id[0]-1+i], 64, 0);
				sys_call(6, "gmt psxy ", FILET, mapv, PEN2S, " -P -O -K >>", FILEP);
			}
		}
		wrt_tmp2(i1, i2, CONT, Vln+Id[0]-1, Vlt+Id[0]-1);
		if (Opt & PLOT_PATH){
			sys_call(6, "gmt psxy ", FILET, mapv, PEN3S, " -P -O -K >>", FILEP);
		}
		sys_call(6, "gmt psxy ", FILET, mapv, CIRC2S, " -P -O -K >>", FILEP);
	}

	/* plot a mean VGP & a circle of A95 */

	if (Opt & PLOT_MEAN){
		psv_a95v2(Vtm, Vnm, A95vm, 64, 0);
		sys_call(6, "gmt psxy ", FILET, mapv, PEN3SR, " -P -O -K >>", FILEP);
		sprintf(Buf, CONT, Vnm, Vtm);   wrt_tmp();
		sys_call(6, "gmt psxy ", FILET, mapv, CIRC3SR, " -P -O -K >>", FILEP);
	}
}

/* psv_a95v */

int psv_a95v(slat, slon, inc, dec, a95, na, flip)
int na, flip;
double slat, slon, inc, dec, a95;
{
	int i;
	double inca[NAMAX+1], deca[NAMAX+1], vlat, vlon;

	if ((Fpt = fopen(FILET, "w")) == NULL) error("psv_a95v: error of open a TMP file!");
	if (alph95(inc, dec, a95, na, inca, deca) == -1) return(-1);
	if (flip == 0){
		for (i = 0; i <= na; i++){
			fldvgp(slat, slon, inca[i], deca[i], &vlat, &vlon);
			fprintf(Fpt, CONT, vlon, vlat);
		}
	}
	else if (flip == 1){
		for (i = 0; i <= na; i++){
			fldvgp(slat, slon, inca[i], deca[i], &vlat, &vlon);
			vlon += 180.;   checklon(&vlon, 0);
			fprintf(Fpt, CONT, vlon, -vlat);
		}
	}
	fclose(Fpt);
	return(1);
}

/* psv_a95v2 */

int psv_a95v2(plat, plon, a95, na, flip)
int na, flip;
double plat, plon, a95;
{
	int i;
	double vlat[NAMAX+1], vlon[NAMAX+1];

	if ((Fpt = fopen(FILET, "w")) == NULL) error("psv_a95v2: error of open a TMP file!");
	if (alph95(plat, plon, a95, na, vlat, vlon) == -1) return(-1);
	if (flip == 0)
		for (i = 0; i <= na; i++)
			fprintf(Fpt, CONT, vlon[i], vlat[i]);
	else if (flip == 1)
		for (i = 0; i <= na; i++)
			fprintf(Fpt, CONT, vlon[i], -vlat[i]);
	else
		error("psv_a95v2: wrong flip!");
	fclose(Fpt);
	return(1);
}
#undef CNTMAPV
#undef TICKV
#undef XYV
#undef CONT
#undef CNUMBR
#undef CSITEID
