#include   "std.h"

/* core -- magnetic vector in N-E-Z cordinate from orientation data    7/3/86 */
/*		azim: Eastward positive from geographic north  V-2    6/15/91 */ 

void core(azim, plun, x0, y0, z0, x, y, z)
double azim, plun, x0, y0, z0, *x, *y, *z;
{
	double ax, ay, az;

	rotvec(0., plun, x0, y0, z0, &ax, &ay, &az);
	rotvec(azim, 0., ax, ay, az, x, y, z);
}


/* coren -- inversion of core magnetic vector from in situ vector   7/3/86 */

void coren(azim, plun, x0, y0, z0, x, y, z)
double azim, plun, x0, y0, z0, *x, *y, *z;
{
	double ax, ay, az;

	rotvec(-azim, 0., x0, y0, z0, &ax, &ay, &az);
	rotvec(0., -plun, ax, ay, az, x, y, z);
}
