#include <string.h>
#include "std.h"

static char Buf[LSIZ_GET], Token[NARG_GET][TOKSIZ];

/* getstr -- get a string (blunk is OK) from a stream   11/15/91, 1/26/90
		returns length of the string
*/

int getstr(fp, str, maxleng)
FILE *fp;
char *str;
int maxleng;
{
	char c;
	int  i;

	if (maxleng<1 || maxleng>LSIZ_GET)
		error("getstr: illegal string length.");
	if (fgets(Buf,LSIZ_GET,fp) == NULL)
		return(EOF);
	i = 0;
	while ((c=Buf[i])!='\n' && c!='\r' && c!='\0'){
		str[i++] = c;
		if (i >= maxleng-1)   break;
	}
	str[i] = '\0';
	return (i);
}

/* get_s -- gets up to 16 strings (<=50 characters) from a stream   1/26/90 
	    Ver.2 -- overflow of Token[] for a long line is treated
*/

int get_s(fp,n,s1,s2,s3,s4,s5,s6,s7,s8,s9,s10,s11,s12,s13,s14,s15,s16)
FILE *fp;
char *s1,*s2,*s3,*s4,*s5,*s6,*s7,*s8,*s9,*s10,*s11,*s12,*s13,*s14,*s15,*s16;
int n;
{
	char *ptoken, *delims = " ,\t\n";
	int ni, i;

	if (fgets(Buf,LSIZ_GET,fp) == NULL)
		return(EOF);
	i = 0;
	ptoken = strtok(Buf, delims);
	while (ptoken != NULL){
		if (i >= NARG_GET) break;
		strcpy(Token[i++], ptoken);
		ptoken = strtok(NULL, delims);
	}
	ni = i;
	if (ni < n){
		i = ni;
		while (i < n)
			strcpy(Token[i++], " ");
	}
	strcpy(s1, Token[0]);   if (n == 1)   return(ni);
	strcpy(s2, Token[1]);   if (n == 2)   return(ni);
	strcpy(s3, Token[2]);   if (n == 3)   return(ni);
	strcpy(s4, Token[3]);   if (n == 4)   return(ni);
	strcpy(s5, Token[4]);   if (n == 5)   return(ni);
	strcpy(s6, Token[5]);   if (n == 6)   return(ni);
	strcpy(s7, Token[6]);   if (n == 7)   return(ni);
	strcpy(s8, Token[7]);   if (n == 8)   return(ni);
	strcpy(s9, Token[8]);   if (n == 9)   return(ni);
	strcpy(s10, Token[9]);   if (n == 10)   return(ni);
	strcpy(s11, Token[10]);   if (n == 11)   return(ni);
	strcpy(s12, Token[11]);   if (n == 12)   return(ni);
	strcpy(s13, Token[12]);   if (n == 13)   return(ni);
	strcpy(s14, Token[13]);   if (n == 14)   return(ni);
	strcpy(s15, Token[14]);   if (n == 15)   return(ni);
	strcpy(s16, Token[15]);   return(ni);
}

/* linecount -- count lines of a file (fp is rewinded afterward)   121496
		skip comment which begins by one char in delim   121500
		when no comments, assign "" for delim
	Example of lines with '#' & '%' at the head, and a blunk line.
		N = linecount(fp, "#%\n")
	** Discontinued **   1019

int linecount(fp, delim)
FILE *fp;
char *delim;
{
	int i = 0;

	if (strcmp(delim, "") == 0)
		while (fgets(Buf, LSIZ_GET, fp) != NULL)
			i++;
	else {
		while (fgets(Buf, LSIZ_GET, fp) != NULL){
			if (strchr(delim, Buf[0]) != NULL) continue;
			i++;
		}
	}
	rewind(fp);
	return(i);
}
*/

/* getoption -- take up to 5 options in command interpretation   021698 */

void getoption(str, n, str1, str2, str3, str4, str5)
char *str, *str1, *str2, *str3, *str4, *str5;
int n;
{
	char *ptr, buf[100], token[6][TOKSIZ];
	int ni, i = 0, j = 0;

	if (n < 1 || n > 5) error("Illegal n at getoption!");
	ptr = str;
        while (*ptr != '\0'){
                if (*ptr == '/'){
                        *(buf + j) = '\0';
                        strcpy(token[i++], buf);
                        j = 0;   ptr++;
                        continue;
                }
                *(buf + j++) = *ptr++;
        }
        *(buf + j) = '\0';
        strcpy(token[i++], buf);
	ni = i;
	while (ni < n)
		strcpy(token[ni++], "");
	strcpy(str1, token[0]);   if (n == 1) return;
	strcpy(str2, token[1]);   if (n == 2) return;
	strcpy(str3, token[2]);   if (n == 3) return;
	strcpy(str4, token[3]);   if (n == 4) return;
	strcpy(str5, token[4]);   return;
}
