#include <math.h>
#include "std.h"

/* vecmuls -- return a scalar (inner) product of vectors a & b   090803 */

double vecmuls(ax, ay, az, bx, by, bz)
double ax, ay, az, bx, by, bz;
{
	return ax*bx + ay*by + az*bz;
}


/* vecumuls -- return a scalar product, cos(dif angle), of two unit vectors */

double vecumuls(ainc, adec, binc, bdec)
double ainc, adec, binc, bdec;
{
	double ai, bi, dd;

	ai = ainc/RAD;   bi = binc/RAD;
	dd = (adec - bdec)/RAD;
	return sin(ai)*sin(bi) + cos(ai)*cos(bi)*cos(dd);
}


/* vecmulv -- vector (outer) product of vectors a & b */

void vecmulv(ax, ay, az, bx, by, bz, cx, cy, cz)
double ax, ay, az, bx, by, bz, *cx, *cy, *cz;
{
	*cx = ay*bz - az*by;
	*cy = az*bx - ax*bz;
	*cz = ax*by - ay*bx;
}


/* vecumulv -- vector product of unit vectors */

void vecumulv(ainc, adec, binc, bdec, cinc, cdec)
double ainc, adec, binc, bdec, *cinc, *cdec;
{
	double ax, ay, az, bx, by, bz, cx, cy, cz, dumm;

	magcar(1., ainc, adec, &ax, &ay, &az);
	magcar(1., binc, bdec, &bx, &by, &bz);
	vecmulv(ax, ay, az, bx, by, bz, &cx, &cy, &cz);
	carmag(cx, cy, cz, &dumm, cinc, cdec);
}
