#include <math.h>
#include "std.h"

static int daytab[2][13] = {
	{0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31},
	{0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31}
};
static double yeartab[2] = {365., 366.};
static int leap, i;

/* ymdtoy -- [year,month,day] to decimal year   032620 */

double ymdtoy(year, month, day, days)
int year, month, day, *days;
{

	if ((year%4==0 && year%100!=0) || year%400==0)
		leap = 1;
	else
		leap = 0;
	*days = day;
	for (i=1; i<month; i++)
		*days += daytab[leap][i];
	return (double)year + (double)(*days)/yeartab[leap];
}

/* ytoymd -- decimal year to [year,month,day] */

void ytoymd(dyear, year, month, day)
int *year, *month, *day;
double dyear;
{
	int ydays;
	double dum1, dum2;

	dum1 = modf(dyear, &dum2);
	*year = dum2;
	if (((*year)%4==0 && (*year)%100!=0) || (*year)%400==0)
		leap = 1;
	else
		leap = 0;
	ydays = yeartab[leap]*dum1 + 0.5;
	month_day(ydays, month, day);
}

/* doytomd -- day of year to month & day */

void doytomd(year, yday, month, day)
int year, yday, *month, *day;
{
	if ((year%4==0 && year%100!=0) || year%400==0)
		leap = 1;
	else
		leap = 0;
	month_day(yday, month, day);
}

/* month_day -- day of year to month & day
		args exclude year but refers to static int leap
*/

void month_day(yday, month, day)
int yday, *month, *day;
{
	for (i=1; yday>daytab[leap][i]; i++)
		yday -= daytab[leap][i];
	*month = i;
	*day = yday;
}
